//------------------------------------------------------------------------
// Name:        QuickPlay
// Version:     3.6
// Author:      John Scott
// Homepage:    http://www.smackdown-hotel.fsnet.co.uk
// Description: QuickPlay is a multi-emulator frontend, key features include
//              extreme ease of use (similar to EXPLORER)
//              EmuFinder for adding your emulators quickly
//              Support for ZIP files
//              FAST - thanks to Virtual Treeview component.
//              OLE and VCL drag'n'drop.
//              Enhance MAME support
//                      Support for Mamus icon set
//                      CatVer.ini file for getting gametype
//                      MAME game renamer, and year
//              Image Panel for displaying images for ROMs
//
// License:      BSD License
//------------------------------------------------------------------------
unit fMain;

interface
           
uses Windows, Classes, Graphics, Controls, Forms,
     Dialogs, Menus, ComCtrls, StdActns, ActnList, ImgList,
     activeX, ExtCtrls, StdCtrls,  Contnrs, GraphicEX,
     VirtualTrees, uSettings, JvComponent, Messages, 
     JvTrayIcon, JvDragDrop, JvAppInst, ToolWin,
     uQPDir, uRomList, uEmuList, uRom, uEmu, JvBaseThumbnail,
     JvThumbViews, JvExForms, SysUtils;

type

  TQPRefresh = (QPRClone, QPRNone, QPRPath, QPRZip);

  TMainFrm = class(TForm)
    ImageList1: TImageList;
    ActionList: TActionList;
    ActNewFol: TAction;
    ActDelFol: TAction;
    ActScan: TAction;
    StatusBar: TStatusBar;
    ActClearRoms: TAction;
    ActEmuDel: TAction;
    ActAddRom: TAction;
    RomPopUp: TPopupMenu;
    popClear: TMenuItem;
    PopAdd: TMenuItem;
    ActRunRom: TAction;
    PopRunRom: TMenuItem;
    DirPopUp: TPopupMenu;
    PopNew: TMenuItem;
    PopDel: TMenuItem;
    popScan: TMenuItem;
    N3: TMenuItem;
    ActDelRom: TAction;
    PopDelRom: TMenuItem;
    N7: TMenuItem;
    ActEmuMan: TAction;
    RunWith: TMenuItem;
    ActAddFav: TAction;
    ActOrgFav: TAction;
    ActFindRom: TAction;
    ActExplore: TAction;
    PopExplore: TMenuItem;
    N10: TMenuItem;
    ActOrphans: TAction;
    PopAddtoFav: TMenuItem;
    ActRefresh: TAction;
    temp: TMenuItem;
    DirPanel: TPanel;
    RomPanel: TPanel;
    ActCatVer: TAction;
    ActZip: TAction;
    SplitMain: TSplitter;
    IconList: TImageList;
    ActSelAll: TAction;
    ActEmuFind: TAction;
    ActAbout: TAction;
    ActMameRen: TAction;
    ActExport: TAction;
    ActFolOpt: TAction;
    FolderOptions1: TMenuItem;
    ActRomProp: TAction;
    RomProperties1: TMenuItem;
    PanImage: TPanel;
    SplitImage: TSplitter;
    ActColumns: TAction;
    PopHeader: TPopupMenu;
    HideShowColumns1: TMenuItem;
    ActEFindEdit: TAction;
    ActRunDlg: TAction;
    RunRomWithDialog1: TMenuItem;
    ActFileRename: TAction;
    RenameFileonDisk1: TMenuItem;
    ActHelpContents: TAction;
    PanRomTop: TPanel;
    TxtFilter: TEdit;
    lblFilter: TLabel;
    ActAddIPS: TAction;
    AddIPS1: TMenuItem;
    IPSMenu: TMenuItem;
    ActMirror: TAction;
    N2: TMenuItem;
    VTRoms: TVirtualStringTree;
    ROMicons: TImageList;
    ActRBarVisible: TAction;
    ActUpdate: TAction;
    ActPref: TAction;
    MainMenu: TMainMenu;
    ActExit: TFileExit;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    NewFolder1: TMenuItem;
    DeleteFolder1: TMenuItem;
    View1: TMenuItem;
    N4: TMenuItem;
    HideShowColumns2: TMenuItem;
    N5: TMenuItem;
    Refresh1: TMenuItem;
    SelectAll1: TMenuItem;
    MnuFav: TMenuItem;
    AddToTop101: TMenuItem;
    OrganiseTop101: TMenuItem;
    N6: TMenuItem;
    Emulators1: TMenuItem;
    EmulatorList1: TMenuItem;
    N8: TMenuItem;
    ClearEmulators1: TMenuItem;
    N9: TMenuItem;
    LaunchEmuFinder1: TMenuItem;
    EditEmuFinderDataFiles1: TMenuItem;
    Roms1: TMenuItem;
    Mame1: TMenuItem;
    Help1: TMenuItem;
    RunROM1: TMenuItem;
    RunROMWithDialog2: TMenuItem;
    N11: TMenuItem;
    AddaROM1: TMenuItem;
    ScanForROMS1: TMenuItem;
    RescanMirroredDirectory1: TMenuItem;
    AddIPS2: TMenuItem;
    N12: TMenuItem;
    DeleteROM1: TMenuItem;
    ClearROMlist1: TMenuItem;
    N13: TMenuItem;
    ExploreROMDirectory1: TMenuItem;
    N14: TMenuItem;
    FindROM1: TMenuItem;
    RemoveOrphanedFiles1: TMenuItem;
    ZipUtilities1: TMenuItem;
    ProcessCurrentDirwithcatveriniMAMEOnly1: TMenuItem;
    RenameMameROMS1: TMenuItem;
    ools1: TMenuItem;
    CheckforUpdates1: TMenuItem;
    Preferences1: TMenuItem;
    HelpContents1: TMenuItem;
    About1: TMenuItem;
    TBRoms: TToolBar;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ShowHideRomToolbar1: TMenuItem;
    ActDBarVisible: TAction;
    ShowHideDirectoryToolbar1: TMenuItem;
    PanFilter: TPanel;
    ActFilterVisible: TAction;
    ShowHideROMFilter1: TMenuItem;
    ACtHomePage: TAction;
    GotoEmulatorHomePage1: TMenuItem;
    N16: TMenuItem;
    GotoEmulatorHomePage2: TMenuItem;
    ActImgVisible: TAction;
    ShowImagePanel2: TMenuItem;
    ActMultiScan: TAction;
    MultiDirectoryScan1: TMenuItem;
    N15: TMenuItem;
    ExporttoHTML1: TMenuItem;
    ActMergedScan: TAction;
    ScanMergedROMs1: TMenuItem;
    RumRandomROM1: TMenuItem;
    ActRandomFolder: TAction;
    ActRandomAll: TAction;
    FromThisFolder1: TMenuItem;
    FromAllROMs1: TMenuItem;
    N17: TMenuItem;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ActResetConfig: TAction;
    ResetConfiguration1: TMenuItem;
    ActMigrate: TAction;
    DriveFolderMigrationWizard1: TMenuItem;
    EmuFolders: TImageList;
    jvTray: TJvTrayIcon;
    ActBackupRestore: TAction;
    N18: TMenuItem;
    BackupRestoreConfiguration1: TMenuItem;
    jvDropROM: TJvDropTarget;
    jvAppInst: TJvAppInstances;
    ActCustomData: TAction;
    N19: TMenuItem;
    ActNPlayers: TAction;
    ProcessNPlayersiniMAMEonly1: TMenuItem;
    ActOpenCatver: TAction;
    ActOpenNPlayers: TAction;
    GotoCatverhomepage1: TMenuItem;
    GotoNPlayersHomepage1: TMenuItem;
    N20: TMenuItem;
    N21: TMenuItem;
    ImportExportCustomROMData2: TMenuItem;
    N22: TMenuItem;
    pgSideBar: TPageControl;
    TabROMS: TTabSheet;
    TabEmus: TTabSheet;
    VTdir: TVirtualStringTree;
    TBDir: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton5: TToolButton;
    ToolButton4: TToolButton;
    VTEmus: TVirtualStringTree;
    PanEmuChk: TPanel;
    ChkEmuBySys: TCheckBox;
    CmbFilterOn: TComboBox;
    jvThumb: TJvThumbView;
    ImgROM: TImage;
    procedure FormCreate(Sender: TObject);
    procedure ActClearRomsExecute(Sender: TObject);
    procedure ActEmuDelExecute(Sender: TObject);
    procedure ActDelFolExecute(Sender: TObject);
    procedure ActNewFolExecute(Sender: TObject);
    procedure ActAddRomExecute(Sender: TObject);
    procedure ActRunRomExecute(Sender: TObject);
    procedure ActDelRomExecute(Sender: TObject);
    procedure ActEmuManExecute(Sender: TObject);
    procedure ActScanExecute(Sender: TObject);
    procedure ActionListUpdate(Action: TBasicAction; var Handled: Boolean);
    procedure ActFindRomExecute(Sender: TObject);
    procedure ActExploreExecute(Sender: TObject);
    procedure ActOrphansExecute(Sender: TObject);
    procedure FavClick(Sender : TObject);
    procedure RomPopUpPopup(Sender: TObject);
    procedure RunWithClick(Sender: TObject);
    procedure ActOrgFavExecute(Sender: TObject);
    procedure ActAddFavExecute(Sender: TObject);
    procedure ActRefreshExecute(Sender: TObject);
    procedure ActCatVerExecute(Sender: TObject);
    procedure ActZipExecute(Sender: TObject);
    procedure ActPrefExecute(Sender: TObject);
    procedure ActSelAllExecute(Sender: TObject);
    procedure ActEmuFindExecute(Sender: TObject);
    procedure ActAboutExecute(Sender: TObject);
    procedure ActMameRenExecute(Sender: TObject);
    procedure ActExportExecute(Sender: TObject);
    procedure ActFolOptExecute(Sender: TObject);
    procedure VTRomsGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure VTRomsGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure ActRomPropExecute(Sender: TObject);
    procedure ActColumnsExecute(Sender: TObject);
    procedure ActEFindEditExecute(Sender: TObject);
    procedure ActRunDlgExecute(Sender: TObject);
    procedure ActFileRenameExecute(Sender: TObject);
    procedure ActHelpContentsExecute(Sender: TObject);
    procedure VTRomsHeaderClick(Sender: TVTHeader; Column: TColumnIndex;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure TxtFilterKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ActAddIPSExecute(Sender: TObject);
    procedure ActMirrorExecute(Sender: TObject);
    procedure IPSMenuClick(Sender: TObject);
    procedure VTRomsIncrementalSearch(Sender: TBaseVirtualTree;
      Node: PVirtualNode; const SearchText: WideString;
      var Result: Integer);
    procedure VTRomsGetHint(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure VTdirInitNode(Sender: TBaseVirtualTree; ParentNode,
      Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
    procedure VTdirInitChildren(Sender: TBaseVirtualTree;
      Node: PVirtualNode; var ChildCount: Cardinal);
    procedure VTdirGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure VTdirGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure VTdirGetHint(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure VTdirGetPopupMenu(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; const P: TPoint;
      var AskParent: Boolean; var PopupMenu: TPopupMenu);
    procedure VTRomsCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure ActRBarVisibleExecute(Sender: TObject);
    procedure ActDBarVisibleExecute(Sender: TObject);
    procedure ActFilterVisibleExecute(Sender: TObject);
    procedure ACtHomePageExecute(Sender: TObject);
    procedure ActImgVisibleExecute(Sender: TObject);
    procedure VTdirDragDrop(Sender: TBaseVirtualTree; Source: TObject;
      DataObject: IDataObject; Formats: TFormatArray; Shift: TShiftState;
      Pt: TPoint; var Effect: Integer; Mode: TDropMode);
    procedure VTdirDragOver(Sender: TBaseVirtualTree; Source: TObject;
      Shift: TShiftState; State: TDragState; Pt: TPoint; Mode: TDropMode;
      var Effect: Integer; var Accept: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure VTRomsChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure VTdirFocusChanging(Sender: TBaseVirtualTree; OldNode,
      NewNode: PVirtualNode; OldColumn, NewColumn: TColumnIndex;
      var Allowed: Boolean);
    procedure ActMultiScanExecute(Sender: TObject);
    procedure VTdirEditing(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; var Allowed: Boolean);
    procedure VTdirNewText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; NewText: WideString);
    procedure VTRomsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure VTdirKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure VTRomsEditing(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; var Allowed: Boolean);
    procedure VTRomsNewText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; NewText: WideString);
    procedure VTRomsCreateEditor(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; out EditLink: IVTEditLink);
    procedure ActMergedScanExecute(Sender: TObject);
    procedure ActRandomFolderExecute(Sender: TObject);
    procedure ActRandomAllExecute(Sender: TObject);
    procedure ActResetConfigExecute(Sender: TObject);
    procedure ActMigrateExecute(Sender: TObject);
    procedure VTdirCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure ActBackupRestoreExecute(Sender: TObject);
    procedure jvDropROMDragDrop(Sender: TJvDropTarget;
      var Effect: TJvDropEffect; Shift: TShiftState; X, Y: Integer);
    procedure jvDropROMDragAccept(Sender: TJvDropTarget;
      var Accept: Boolean);
    procedure VTRomsFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure VTdirFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure ActCustomDataExecute(Sender: TObject);
    procedure ActNPlayersExecute(Sender: TObject);
    procedure VTRomsExit(Sender: TObject);
    procedure VTdirExit(Sender: TObject);
    procedure ActOpenCatverExecute(Sender: TObject);
    procedure ActOpenNPlayersExecute(Sender: TObject);
    procedure VTEmusInitNode(Sender: TBaseVirtualTree; ParentNode,
      Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
    procedure VTEmusGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure ChkEmuBySysClick(Sender: TObject);
    procedure VTEmusInitChildren(Sender: TBaseVirtualTree;
      Node: PVirtualNode; var ChildCount: Cardinal);
    procedure VTEmusGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure VTEmusDblClick(Sender: TObject);
    procedure VTEmusCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure jvThumbDblClick(Sender: TObject);
    procedure ImgROMDblClick(Sender: TObject);

  private
    FFiltered : Integer;
    FFilterString : String;
    FFilterByStart : Boolean;
    FDirHeight : Integer;
    DirList : TObjectList;
    OldWindowState : TWindowState;
    SystemList : TObjectList;
    procedure ClearAllDynMenus();
    procedure DynRunwith(sender : TObject);
    procedure FilterRoms();
    procedure FocusChangeRoms(NewFol : TQPDir; NewNode : PVirtualNode);
    procedure FocusChangeSearch(NewFol : TQPDir; NewNode : PVirtualNode);
    procedure init();
    Procedure InitTree();
    Procedure InitEmuTree();
    Function InitialiseDirectory(CurFol : TQPDir; Node : PVirtualNode) : Integer;
    Function InitialiseSearch(CurFol : TQPDir; Node : PVirtualNode) : Integer;
    procedure PopmenuBuild();
    procedure PopmenuIPS();
    procedure ResetImage();
    Procedure RunIPSGame(Sender : TObject);
    function SelectedFolder:string;
    function SelectedQPDir() : TQPDir;
    function SelectedTxtFile():String;
    function TreeImages(inifile:String) : Integer ;
    procedure RefreshAll();
    function GetSplitDir: Integer;
    function GetSplitImage: Integer;
    procedure SetSplitDir(const Value: Integer);
    procedure SetSplitImage(const Value: Integer);
  public
    Settings : TQPSettings;
    FavList : TQPRomList;
    RomList : TQPRomList;
    EmuList : TQPEmuList;
    FRealIconDir : String;
    RealIconOn : Boolean;
    
    Function GetROM(cNode : PVirtualNode) : TQPRom;
    Function GetNextROM() : TQPRom;
    Function GetPreviousROM() : TQPRom;
    Property GetSelectedFolder : string read SelectedFolder;
    Property GetSelectedTxt : string read SelectedTxtFile;
    Property GetSelectedQPDir : TQPDir read SelectedQPDir;
    Property SplitImagePos : Integer read GetSplitImage write SetSplitImage;
    Property SplitDirPos : Integer read GetSplitDir write SetSplitDir;

    procedure BuildFavMenu();
    procedure ClearROMIcons();
    procedure fillroms(FiletoLoad : TFileName);
    Function  JumpToROM(Dir, ROM : String; SType : TQPRefresh) : Boolean;
    Procedure MinimiseQP();
    Procedure RestoreQP();
    Procedure RunROM(aRom : TQPRom; aEmu : TQPEmu);
    Function  GetDirHeight(): Integer;
    Procedure SetDirImage();
    procedure SetROMHeight(Minimum : Integer);
  end;

const
  QPVer = '3.6.3';
  DefaultFileName = 'ROMData.dat';
  LBreak = Chr(13) + Chr(10);
  
var
  MainFrm: TMainFrm;

implementation

uses JCLstrings, JCLFileUtils, StrUtils, FindFile, ShellAPI, IniFiles,
     fScan, fAddaRom, fMameRename, fFind, fFav, fOptions, fEmuFind,
     fExport, uJUtilities, fZip, fAbout, fFolderOpt, fRomProperties,
     fColumns, fEditEmuFind, fRunDlg, fEmulators, fIPS, fScanRecursive,
     fMameMerge, fWelcome, fMigrate, fBackup, uJVirtualTree,
     uJZip, uJFile, uRomUtils, uEmuUtils, fCustomRomData, uQPVTEditor, uQuery,
     uQPConst;

{$R *.DFM}

{$R ZipMsgUS.res}
{$R defaults.res}
{$WARN SYMBOL_PLATFORM OFF}
{$I Compilers.inc}

{-----------------------------------------------------------------------------}
{-----------------------------------------------------------------------------}
{------------------------------ Private Routines -----------------------------}
{-----------------------------------------------------------------------------}
{-----------------------------------------------------------------------------}

procedure TMainFrm.ClearAllDynMenus();
Begin 
  RunWith.Clear;
  IPSMenu.Clear;
  MnuFav.Clear;
End;

{-----------------------------------------------------------------------------}

procedure TMainFrm.DynRunwith(sender : TObject);
var
  RDialog : TFrmRunRom;
  Tmp : TmenuItem;
  tmpRom : TQPROM;
begin

  Tmp := sender as TMenuItem;

  if VTRoms.SelectedCount = 1 then
  begin

    If Settings.UseRunDLG then
    Begin

      Rdialog := TFrmRunRom.Create(self);
      Try
        RDialog.Rom := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode));
        RDialog.Emu := EmuList[Tmp.Tag];

        RDialog.ShowModal;

      finally
        FreeAndNil(RDialog);
      end;
    end
    
    Else

    Begin
      tmpROM := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode));
      RunROM(tmpRom, EmuList[Tmp.Tag]);
    End;

  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.FilterRoms();
var
  aNode : PVirtualNode;
  Data : TQPRom;
  PosResult : Integer;
Begin
  //firstly reset all the variables.
  FFiltered := 0;

  VTRoms.BeginUpdate;

  //first thing to do is check if a filter string has been provided
  If FFilterString = '' then
  begin

    //no filter string provided, set all ROMs to be visible.
    aNode := VTRoms.GetFirst;
    While aNode <> nil do
    begin
      VTRoms.IsVisible[aNode] := True;
      aNode := VTRoms.GetNext(aNode);
    end;
    
  end
  else
  begin

    //there is a filter string, we need to filter ROMs.  
    aNode := VTRoms.GetFirst;
    While aNode <> nil do
    begin
      data := TQPRom(GetObject(VTRoms, aNode));
      PosResult := 0;
      case CmbFilterOn.ItemIndex of
        0 : PosResult := Pos(FFilterString, lowercase(data.name));
        1 : PosResult := Pos(FFilterString, lowercase(data.Path));
        2 : PosResult := Pos(FFilterString, lowercase(data.GameType));
        3 : PosResult := Pos(FFilterString, lowercase(data.Emulator));
        4 : PosResult := Pos(FFilterString, lowercase(data.Multiplayer));
        5 : PosResult := Pos(FFilterString, lowercase(data.Company));
        6 : PosResult := Pos(FFilterString, lowercase(data.Year));
        7 : PosResult := Pos(FFilterString, lowercase(data.Rating));
      end;

      // if the ROM name contains the filter string, make sure its visible.
      if PosResult = 0 then
      begin
        Inc(FFiltered);
        VTRoms.IsVisible[aNode] := False;
      end
      else
      Begin
        VTRoms.IsVisible[aNode] := True;
      end;

      aNode := VTRoms.GetNext(aNode);
    end;

  end;

  VTRoms.EndUpdate;

End;

{-----------------------------------------------------------------------------}

procedure TMainFrm.init();
begin

  InitTree;

  //set the initially selected node.
  VTDir.Selected[VTDir.GetFirst] := True;
  VTDir.focusedNode := VTDir.GetFirst;

  //Build the favourites
  BuildFavMenu;

end;

{-----------------------------------------------------------------------------}
procedure TMainFrm.InitEmuTree();
var
  TempSys : TStringList;
  i : Integer;
  NewSys : TQPSystem;
  NewIndex : Integer;
begin
  VTEmus.Clear;
  SystemList.Clear;

  if ChkEmuBySys.Checked then
  begin
    //we want the emulators sorted by system
    TempSys := TStringList.Create;
    try
      TempSys.LoadFromFile(MainFrm.Settings.SettingsDir + 'systems.dat');
   
      for i := 0 to TempSys.Count-1 do
      Begin
        NewIndex := SystemList.Add(TQPSystem.Create);
        NewSys := TQPSystem(SystemList.items[NewIndex]);

        NewSys.Name := TempSys.Strings[i];
        NewSys.TotalEmus := 0;
      End;

    Finally
      FreeAndNil(TempSys);
    end;

    VTEmus.RootNodeCount := SystemList.Count;

  end
  else
  begin
    //we want a flat listing of all emulators.
    SystemList.Clear;
    VTEmus.RootNodeCount := EmuList.Count;
  end;
end;

Procedure TMainFrm.InitTree();
var
  i : Integer;
Begin

  VTDir.Clear;
  VTDir.RootNodeCount := 0;
  
  //now we clear our objectlist
  DirList.Clear;

  //we also need to clear the directory listing icon list
  //well we need to leave the original 4 intact!
  if IconList.Count > 4 then
    For i:= IconList.Count-1 downto 4 do
      IconList.Delete(i);

  //calculate the height of the nodes.
  FDirHeight := GetDirHeight();

  //now add 2 objects for the root directories.
  DirList.Capacity := 2;
  DirList.Add(TQPDir.Create(QP_ROMS, Settings.ROMsDir, dtROMs, false, 0, 1));
  DirList.Add(TQPDir.Create(QP_MAINFRM_VIRTUAL, Settings.SearchDir, dtSearch, False, 3, 3));

  VTDir.BeginUpdate;
  //Set up the treeview with the available directories.
  VTdir.RootNodeCount := 2;
  VTDir.ValidateNode(VTDir.GetFirst, true);
  VTDir.EndUpdate;

End;

Function TMainFrm.InitialiseDirectory(CurFol : TQPDir; Node : PVirtualNode) : Integer;
var
  childfol : TQPDir;
  SR: TSearchRec;
  ChildNode: PVirtualNode;
  NewIcon : Integer;
begin
  //this code is for directory listing part of the tree
  //do a search for files, including directories (its directories we want!)
  if FindFirst(IncludeTrailingPathDelimiter(CurFol.FullPath) + '*.*', faDirectory, SR) = 0 then
  begin
    try
      //begin iteration of all files found in the directory
      repeat
        if (SR.Name <> '.') and (SR.Name <> '..') then
        begin
          //if the file found is indeed a directory we can add it.
          if (SR.Attr and faDirectory <> 0) then
          begin
            //fill the child nodes data record
            DirList.Add(TQPDir.Create(SR.Name, IncludeTrailingPathDelimiter(IncludeTrailingPathDelimiter(CurFol.FullPath) + SR.Name), CurFol.DirType, false, 0, 1));
            ChildNode := VTDir.AddChild(Node);
            SetObject(VTDir, ChildNode, DirList.Last);
            //now work out if they require a special icon.
            ChildFol := TQPDir(GetObject(VTDir, ChildNode));
            NewIcon := TreeImages(ChildFol.FullPath+'folders.ini');
            If NewIcon <> -1 then
            begin
              ChildFol.CustomIcon := True;
              ChildFol.NormalIcon := NewIcon;
              ChildFol.SelIcon := NewIcon;
              If FDirHeight < 24 then
                VTDir.NodeHeight[ChildNode] := 24
              else
                VTDir.NodeHeight[ChildNode] := FDirHeight;
            end
            else
              VTDir.NodeHeight[ChildNode] := FDirHeight;

            VTDir.ValidateNode(Node, False);
          end;
        end;
      //repeat until no more results are found.
      until FindNext(SR) <> 0;
      //the childcount is the number of nodes we have just added above.
      Result := VTDir.ChildCount[Node];

    finally
      //remember to free the memory of the file search.
      FindClose(SR);
    end;
  end
  else
    Result := 0;
  //end of code for initialising directory view.
end;

Function TMainFrm.InitialiseSearch(CurFol : TQPDir; Node : PVirtualNode) : Integer;
var
  childfol : TQPDir;
  SR: TSearchRec;
  ChildNode: PVirtualNode;
  NewIcon : Integer;
begin
  //do a search for files, including directories (its directories we want!)
  if FindFirst(IncludeTrailingPathDelimiter(CurFol.FullPath) + '*.qpq', faAnyFile	, SR) = 0 then
  begin
    try
      //begin iteration of all files found in the directory
      repeat
        if (SR.Name <> '.') and (SR.Name <> '..') then
        begin
          //if the file found is indeed a directory we can add it.
          DirList.Add(TQPDir.Create(ChangeFileExt(SR.Name, ''), IncludeTrailingPathDelimiter(CurFol.FullPath) + SR.Name, CurFol.DirType, false, 0, 1));
          ChildNode := VTDir.AddChild(Node);
          SetObject(VTDir, ChildNode, DirList.Last);
          //now work out if they require a special icon.
          ChildFol := TQPDir(GetObject(VTDir, ChildNode));
          NewIcon := -1;
          If NewIcon <> -1 then
          begin
            ChildFol.CustomIcon := True;
            ChildFol.NormalIcon := NewIcon;
            ChildFol.SelIcon := NewIcon;
            If FDirHeight < 24 then
              VTDir.NodeHeight[ChildNode] := 24
            else
              VTDir.NodeHeight[ChildNode] := FDirHeight;

          end
          else
            VTDir.NodeHeight[ChildNode] := FDirHeight;

          VTDir.ValidateNode(Node, False);
        end;
      //repeat until no more results are found.
      until FindNext(SR) <> 0;
      //the childcount is the number of nodes we have just added above.
      Result := VTDir.ChildCount[Node];

    finally
      //remember to free the memory of the file search.
      FindClose(SR);
    end;
  end
  else
    Result := 0;
end;

{-----------------------------------------------------------------------------}

function TMainFrm.GetSplitDir: Integer;
begin
  result := DirPanel.Width;
end;

{-----------------------------------------------------------------------------}

function TMainFrm.GetSplitImage: Integer;
begin
  result := PanImage.Width;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.SetSplitDir(const Value: Integer);
begin
  DirPanel.Width := Value;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.SetSplitImage(const Value: Integer);
begin
  PanImage.Width := Value;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.PopmenuBuild();
var
  NewItem: TMenuItem;
  CurEmu : TQPEmu;
  i : Integer;
begin
  //Clear any present menu entries.
  RunWith.Clear;
  //for i := RunWith.Count-1 Downto 0 do
  //  RunWith.Items[i].free;

  //Build the menu with emulators with the same system as the rom.
  if VTRoms.selectedCount = 1 then
  begin

    CurEmu := EmuList.GetEmuForROM(TQPRom(GetObject(VTRoms, VTRoms.FocusedNode)));

    if CurEmu = nil then
      exit;

    for i := 0 to EmuList.Count-1 do
      if StrCompare(CurEmu.system, EmuList[i].system) = 0 then
      begin
        NewItem := TMenuItem.Create(RunWith);

        if (Settings.AddVersion) AND (EmuList[i].Version <> '') then
          NewItem.Caption := EmuList[i].name +' (' + EmuList[i].Version+')'
        else
          NewItem.Caption := EmuList[i].Name;

        NewItem.Tag := i;
        NewItem.OnClick := DynRunwith;
        RunWith.Add(NewItem);
      end; //end of IF strCompare(the 2 systems)

  end; //end of Selectedcount = 1
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.PopmenuIPS();
var
  NewItem: TMenuItem;
  i: integer;
  ROM : TQProm;
begin
  //Clear any present menu entries.
  IPSMenu.Clear;
  //for i := IPSmenu.Count-1 Downto 0 do
  //  IPSmenu.Items[i].free;

  if VTRoms.FocusedNode <> nil then
  begin

      ROM := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode));

      For i:= 0 to Length(ROM.IPS)-1 do
      Begin
          NewItem := TMenuItem.Create(IPSMenu);
          NewItem.Caption := ROM.IPS[i].Name;
          NewItem.OnClick := RunIPSGame;
          NewItem.Tag := ROM.IPS[i].Index;
          IPSmenu.Add(NewItem);
      end;
  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.RefreshAll();
var
  DirPath : String;
  RomPath : String;
  SType : TQPRefresh;
  CurDir : TQPDir;
begin

  //load in the available emulators.
  EmuList.LoadFromFile;
  //Build the favourites
  BuildFavMenu;

  RomPath := '';
  DirPath := '';
  SType := QPRNone;

  //Store the currently selected Directory AND Rom

  If VTDir.SelectedCount = 1 then
  Begin
  
    CurDir := GetSelectedQPDir;

    if (CurDir <> nil) and (CurDir.DirType = dtROMs) then
    begin
      DirPath := CurDir.FullPath;

      //get the currently selected ROM IF there is one.
      If VTRoms.SelectedCount = 1 then
      Begin
        if TQPRom(GetObject(VTRoms, VTRoms.FocusedNode)).ZipName <> '' then
        begin
          SType := QPRZip;
          RomPath := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode)).ZipName;
        end
        else if TQPRom(GetObject(VTRoms, VTRoms.FocusedNode)).CloneName <> '' then
        begin
          SType := QPRClone;
          RomPath := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode)).CloneName;
        end
        else
        begin
          SType := QPRPath;
          RomPath := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode)).path;
        end;

      End;

    end;
  end;

  //Reload EVERYTHING
  InitTree();

  JumpToROM(DirPath, ROMPath, SType);

  VTRoms.SetFocus;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ResetImage();
begin
  if PanImage.Visible then
  begin
    If FileExists(Settings.Logo) then
      ImgROM.Picture.LoadFromFile(Settings.Logo);
    jvThumb.EmptyList;
    jvThumb.Hide;
    ImgROM.Show;
  end;

end;

{-----------------------------------------------------------------------------}

Procedure TMainFrm.RunIPSGame(Sender : TObject);
Var
  Tmp : TmenuITem;
  ROM : TQPRom;
  Emu : TQPEmu;
begin

  Tmp := sender as TMenuItem;

  if VTRoms.SelectedCount = 1 then
  begin

    rom := TQPROM(GetObject(VTRoms, VTRoms.FocusedNode));
    Emu := EmuList.GetEmuForROM(Rom);

    If Emu <> nil then
    begin
      try

        if Settings.MiniOnRun then
          MinimiseQP();
        try
          Rom.RunIPS(Settings.QPDirectory+'temp\', Emu, Tmp.Tag);
        finally
          If Settings.MiniOnRun then
            RestoreQP();
        end; //end of Finally block
        
      except
        //this is caused by the running of the ROM.
        on EJNotice do MainFrm.Close();
        on E: EJException do MessageDlg(E.Message, mtError, [mbOK], 0);
      end;
    end
    else
      MessageDlg(QP_EMULATOR_NOT_FOUND, mtError, [mbOK], 0);

  end; //end of 1 ROM selected IF Statement

End;

{-----------------------------------------------------------------------------}

function TMainFrm.SelectedFolder():String;
var
  CurFol : TQPDir;
Begin
  //this function returns the full path of the directory
  //of the currently selected VTdir node.
  CurFol := GetSelectedQPDir;
  if (CurFol <> nil) and (CurFol.DirType = dtROMs) then
    SelectedFolder := IncludeTrailingPathDelimiter(CurFol.FullPath)
  else
    SelectedFolder := '';
End;

{-----------------------------------------------------------------------------}

function TMainFrm.SelectedQPDir() : TQPDir;
begin
  Result := nil;

  If VTDir.FocusedNode <> nil then
    Result := TQPDir(GetObject(VTDir, VTDir.FocusedNode));
end;

function TMainFrm.SelectedTxtFile():String;
var
  CurFol : TQPDir;
Begin
  //this function returns the full path for the text file
  //of the currently selected dir tree node.
  CurFol := GetSelectedQPDir;

  if (CurFol <> nil) then
  begin
    case CurFol.DirType of
    dtROMs   : SelectedTxtFile := IncludeTrailingPathDelimiter(CurFol.FullPath)+DefaultFileName;
    dtSearch : SelectedTxtFile := ChangeFileExt(CurFol.FullPath, '.tmp');
    else
      SelectedTxtFile := '';
    end;
  end
  else
    SelectedTxtFile := '';

End;

{-----------------------------------------------------------------------------}

{ This procedure is used if the EmuTree Icons option is enabled.
  It searches inside each data directory and if an icon is found
  then this icon is used in the treeview to represent the directory }
function TMainFrm.TreeImages(inifile:String) : Integer ;
var
  Ini : TMemIniFile;
  Icon : TIcon;
  pos : Integer;
begin

  //this function determines whether a node uses a custom icon in the
  //directory listing.
  //first we check to see if an ini file exists for this node.
  //if it doesnt then set the icons to the standard folder ones.

  TreeImages := -1;

  If FileExists(IniFile) then
    Begin
    //create the Ini file object will we need
    Ini := TMemIniFile.Create(inifile);
    try

      //all these IFS just check that a icon is specified and it exists
      if Ini.ReadBool('Icon', 'ChkIcon', false) then
        if FileExists(Settings.QPDirectory+'Icons\'+Ini.ReadString('Icon','CmbIcon', '')) then
        begin //Start of file exist check

          //we know the icon exists so create a TICON to store it and
          //add it to the array.
          Icon := TIcon.Create;
          try
            Icon.LoadFromFile(Settings.QPDirectory+'Icons\'+Ini.ReadString('Icon','CmbIcon', ''));
            pos := EmuFolders.AddIcon(Icon);
            TreeImages := pos;
          Finally
            FreeAndNil(Icon);
          end;

        end;  //end of file exists check

    //end the try-finally block and free the ini object.
    finally
      FreeAndNil(ini);
    end;
  end;

end;

{-----------------------------------------------------------------------------}
{                          end of PRIVATE routines                            }
{-----------------------------------------------------------------------------}

{-----------------------------------------------------------------------------}
{-----------------------------------------------------------------------------}
{------------------------------Public Routines--------------------------------}
{-----------------------------------------------------------------------------}
{-----------------------------------------------------------------------------}

procedure TMainFrm.BuildFavMenu;
var
  CurFav : TQPRom;
  i : Integer;
  NewItem, tmpItem: TMenuItem;
Begin
    FavList.LoadFromFile(Settings.FavsFile);

    //clear the favourites menu
    for i := MnuFav.Count-1 downto 3 do
    begin
      tmpItem := MnuFav.Items[i];
      FreeAndNil(tmpItem);
    end;

    For i := 0 to FavList.Count-1 do
    Begin
      CurFav := FavList[i];
      NewItem := TMenuItem.Create(MnuFav);
      NewItem.Caption := CurFav.Name + '   (' + CurFav.Emulator + ')';
      NewItem.OnClick := MainFrm.FavClick;
      NewItem.Tag := i;
      MainFrm.MnuFav.Add(NewItem);
    End;

End;

//this code clears the ROMSicons imagelist, and resets all indexs to values
procedure TMainFrm.ClearROMIcons();
var
  i : Integer;
  RIcon : TResourceStream;
  TmpIcon : TIcon;
Begin
  ROMIcons.Clear;
    
  For I := 0 to ROMlist.Count-1 do
    ROMlist[i].IconIndex := -1;

  //now add the default ROM icon depending on which size it is.
  RIcon := TResourceStream.Create(HInstance, 'rom_icon', 'RT_ICON' );
  try

    TmpIcon := TIcon.Create;
    try
      TmpIcon.LoadFromStream(RIcon);
      ROMicons.AddIcon(TmpIcon);
    Finally
      FreeAndNil(TmpIcon);
    end;

  finally
    FreeAndNil(RIcon);
  end;
End;

{-----------------------------------------------------------------------------}

//This procedure fills the listview with roms.
procedure TMainFrm.fillroms(FiletoLoad : TFileName);
var
  OldCursor : TCursor;
  Node : PVirtualNode;
begin

  If FileToLoad = '' then
  Begin
    VTRoms.Clear;
    VTRoms.RootNodeCount := 0;
    ROMlist.Clear;
    
    //set up the actions.
    ActClearRoms.enabled := false;
    StatusBar.SimpleText := QP_MAINFRM_NO_ROMS;
  End
  else
  begin

  //Change the cursor.
  OldCursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;

  try
    //Clear the rom list of any entries.
    VTRoms.Clear;
    VTRoms.RootNodeCount := 0;
      
    //Load the roms for the selected directory.
    ClearRomIcons();
    ROMlist.LoadFromFile(FileToLoad);
    
    VTRoms.BeginUpdate;
    Try
      VTRoms.RootNodeCount := ROMlist.Count;

      Node := VTRoms.GetFirst;
      while Node <> nil do
      begin
        SetObject(VTRoms, Node, ROMlist[Node.Index]);
        Node := Node.NextSibling;
      end;

      //sort the tree now
      VTRoms.SortTree(VTRoms.Header.SortColumn, VTRoms.Header.SortDirection, false);
      
    Finally
      VTRoms.EndUpdate;
    end;

    if ROMlist.Count > 0 then
    begin
      ActClearRoms.enabled := true;
      StatusBar.simpletext := inttostr(ROMlist.Count) + QP_MAINFRM_FILTER_1 + IntToStr(FFiltered) + QP_MAINFRM_FILTER_2;
    end
    else
    begin
      ActClearRoms.enabled := false;
      StatusBar.SimpleText := QP_MAINFRM_NO_ROMS;
    end;
    
    FilterRoms();

    ActEmuDel.Enabled := (EmuList.Count > 0);

  //Change the screen cursor back to normal.
  finally
    Screen.cursor := oldcursor;
  end;
  
  end;

end;

{-----------------------------------------------------------------------------}

Function TMainFrm.JumpToROM(Dir, ROM : String; SType : TQPRefresh) : Boolean;
var
  Sdir : TQPDir;
  RomData : TQPRom;
  DNode, RNode : PVirtualNode;
  DirFound, ROMFound : Boolean;
begin
  DirFound := False;

  //always reset the position back to the root and work from there
  VTDir.Selected[VTDir.GetFirst] := True;
  VTDir.FocusedNode := VTDir.GetFirst;

  //Set focus back to the selected Directory
  if Dir <> '' then
  Begin

    DNode := VTDir.GetFirst;
    While DNode <> nil do
    Begin

      Sdir := TQPDir(GetObject(VTDir, DNode));
      if (Sdir <> nil) and (StrCompare(Sdir.FullPath, Dir)=0) then
      begin
        VTDir.Selected[DNode] := True;
        VTDir.FocusedNode := DNode;
        DirFound := True;
        break;
      end
      else
      begin
        if VTDir.GetNodeLevel(VTDir.GetNext(DNode)) <> 0 then
          DNode := VTDir.GetNext(DNode)
        else
          Dnode := nil;
      end

    end;  //end of WHILE loop

  End;
       
  Result := DirFound;
  
  //now try to get the selected ROM
  if Dirfound then
  begin
    if (ROM <> '') and (SType <> QPRNone) then
    Begin

      RNode := VTRoms.GetFirst;
        While RNode <> nil do
        Begin
          RomData := TQPRom(GetObject(VTRoms, RNode));
          ROMFound := False;
          Case SType of
            QPRZip : ROMFound := (StrCompare(RomData.ZipName, ROM)=0);
            QPRClone : ROMFound := (StrCompare(RomData.CloneName, ROM)=0);
            QPRPath : ROMFound := (StrCompare(RomData.path, ROM)=0);
          end;
          If ROMFound then
          Begin
            VTRoms.Selected[RNode] := true;
            VTRoms.FocusedNode := RNode;
            break;
          End
          Else
            RNode := VTRoms.GetNext(RNode);
        end;

    end; //end of if Rompath <> ''
  end;

end;
{-----------------------------------------------------------------------------}

procedure TMainFrm.MinimiseQP();
begin
  if not Settings.UseOldMini then
  begin
    //we can use the new style using the system tray component.
    jvTray.Active := True;
    jvTray.HideApplication;
  end
  else
  begin
    //use the minimise code from 3.4.3
    OldWindowState := MainFrm.WindowState;

    If MainFrm.WindowState <> wsNormal then
      MainFrm.WindowState := wsNormal;

    MainFrm.WindowState := wsMinimized;
    Application.Minimize();
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.RestoreQP();
begin

  if not Settings.UseOldMini then
  begin
    //we can use the new style using the system tray component.
    jvTray.ShowApplication;
    jvTray.Active := False;
  end
  else
  begin
    //use the minimise code from 3.4.3
    Application.Restore;

    MainFrm.WindowState := OldWindowState;

    Application.ProcessMessages;

    If Application.Active = false then
    Begin
      Application.Restore;
      Application.BringToFront;
    end;
  end;
end;

{-----------------------------------------------------------------------------}

Procedure TMainFrm.RunROM(aRom : TQPRom; aEmu : TQPEmu);
begin
  // A wrapper for running a ROM.  Needed to minimise QP as this is UI business!

  //check that the emulator was actually found.
  if aEmu <> nil then
  begin
    // Minimise QP if needed.
    If Settings.MiniOnRun then
      MinimiseQP();

    try
      aEmu.RunROM(aRom);
    except
      on E: EJNotice do MainFrm.Close;
      on E: EJException do MessageDlg(E.Message, mtError, [mbOK], 0);
    end;
    ROMlist.SaveToFile();

    //Restore QP if needed.
    If Settings.MiniOnRun then
      RestoreQP();

  end
  else
    //the emulator was not found, give an error!
    MessageDlg(QP_LINKED_EMU_NOT_FOUND, mtError, [mbOK], 0);
end;

{-----------------------------------------------------------------------------}

Function TMainFrm.GetROM(cNode : PVirtualNode) : TQPRom;
begin
  if cNode <> nil then
    Result := TQPROM(GetObject(VTRoms, cNode))
  else
    Result := nil;
end;

{-----------------------------------------------------------------------------}

Function TMainFrm.GetNextROM() : TQPRom;
begin
  Result := GetROM(VTRoms.GetNext(VTRoms.GetFirstSelected));
end;

{-----------------------------------------------------------------------------}

Function TMainFrm.GetPreviousROM() : TQPRom;
begin
  Result := GetROM(VTRoms.GetPrevious(VTRoms.GetFirstSelected));
end;

{-----------------------------------------------------------------------------}

Function TMainFrm.GetDirHeight(): Integer;
var
  DC: HDC;
  Canvas: TCanvas;
begin

  Canvas := TCanvas.Create;
  try
    DC := GetDC(0);
    Canvas.Handle := DC;
    Canvas.Font := VTDir.Font;

    Result := Canvas.TextHeight('W');

    if Result < 20 then
      Result := 20;

    Canvas.Handle := 0;
    ReleaseDC(0, DC);

  Finally
    FreeAndNil(Canvas);
  end;
end;

{-----------------------------------------------------------------------------}

Procedure TMainFrm.SetDirImage();
begin
  If Settings.UseBGonDir then
  begin
    if (Settings.DirBGImage <> '') and (FileExists(Settings.DirBGImage) ) then
    begin
      VTDir.Background.LoadFromFile(Settings.DirBGImage);
      VTDir.TreeOptions.PaintOptions := VTDir.TreeOptions.PaintOptions + [toShowBackground]
    end;
  end
  else
    VTDir.TreeOptions.PaintOptions := VTDir.TreeOptions.PaintOptions - [toShowBackground];
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.SetROMHeight(Minimum : Integer);
var
  DC: HDC;
  Canvas: TCanvas;
  NewSize : Integer;
begin

  Canvas := TCanvas.Create;
  try
    DC := GetDC(0);
    Canvas.Handle := DC;
    Canvas.Font := VTRoms.Font;
    NewSize := Canvas.TextHeight('W');

    If NewSize > Minimum then
      VTRoms.DefaultNodeHeight := NewSize
    else
      VTRoms.DefaultNodeHeight := Minimum;

    Canvas.Handle := 0;
    ReleaseDC(0, DC);

  Finally
    FreeAndNil(Canvas);
  end;
end;

{-----------------------------------------------------------------------------}
{                              End of PUBLIC routines                         }
{-----------------------------------------------------------------------------}


{-----------------------------------------------------------------------------}
{                              Action List Routines                           }
{                              Sorted by category                             }
{-----------------------------------------------------------------------------}

procedure TMainFrm.ActionListUpdate(Action: TBasicAction;
  var Handled: Boolean);
var
  Enab : Boolean;
begin

  Enab := (VTRoms.SelectedCount = 1);

  ActRunRom.enabled := Enab;
  ActRunDlg.Enabled := Enab;
  ActExplore.enabled := Enab;
  ActAddFav.enabled := Enab;
  ActAddIPS.Enabled := Enab;
  ActHomePage.Enabled := Enab;
  ActFileRename.Enabled := Enab;

  if VTRoms.SelectedCount > 0 then
    ActDelRom.enabled := true
  else
    ActDelRom.enabled := false;
end;

{-----------------------------------------------------------------------------}
{                              File Menu Actions                              }
{-----------------------------------------------------------------------------}

procedure TMainFrm.ActExportExecute(Sender: TObject);
var
  RomExport : TROMexport;
begin
  VTRoms.BeginUpdate;
  try

    RomExport := TROMexport.create(self);
    try
      RomExport.ShowModal;
    finally
      FreeAndNil(RomExport);
    end;
    
  finally
    VTRoms.EndUpdate;
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActMigrateExecute(Sender: TObject);
var
  Migrate : TFrmMigrate;
begin
  Migrate := TFrmMigrate.Create(Self);
  Try

    If Migrate.ShowModal = mrOK then
      RefreshAll();
      
  finally
    FreeAndNil(Migrate);
  end;
end;

{-----------------------------------------------------------------------------}
{                              Emulator Actions                               }
{-----------------------------------------------------------------------------}

procedure TMainFrm.ActEmuDelExecute(Sender: TObject);
begin

  IF (MessageDlg(QP_EMU_DELETE_ALL,
    mtConfirmation, [mbYes, mbNo], 0) = MrYes) then
  begin
    EmuList.DeleteAll(Settings.SettingsDir);
    ActEmuDel.Enabled := false;
  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActEmuFindExecute(Sender: TObject);
var
  EFind : TEmuFinder;
begin
    EFind := TEmuFinder.create(self);
    try
      If Efind.ShowModal = mrok then
      begin
        FillRoms(GetSelectedTxt);
        ActEmuDel.Enabled := (EmuList.Count > 0);
      end;
    finally
      FreeAndNil(Efind);
    end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActEFindEditExecute(Sender: TObject);
Var
  Edit : TFrmEfindEdit;
begin

  Edit := TFrmEFindEdit.Create(self);
  Try
    Edit.ShowModal;
  Finally
    FreeAndNil(Edit);
  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActEmuManExecute(Sender: TObject);
var
  Emu : TFrmEmuDlg;
begin
    Emu := TFrmEmuDlg.create(self);
    try

      //put a copy of the emulist into a temporary list
      Emu.EmuCopy.LoadFromFile();

      If Emu.ShowModal = mrOk then
        If uEmuUtils.NewListDataCheck(EmuList, Emu.EmuCopy) then
        begin
          Fillroms(GetSelectedTxt);
          ActEmuDel.Enabled := (EmuList.Count > 0);
        end;

    finally
      FreeAndNil(Emu);
    end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ACtHomePageExecute(Sender: TObject);
var
  TmpRom : TQPRom;
  Index : Integer;
begin

  //check that a ROM is selected.
  If VTRoms.SelectedCount = 1 then
  Begin
    TmpRom := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode));
    With MainFrm do
    begin
      Index := EmuList.IndexOfName(TmpRom.Emulator);
      if Index > -1 then
        EmuList[Index].OpenHomePage();
    end;
  End;

end;


{-----------------------------------------------------------------------------}
{                              Favourite Actions                              }
{-----------------------------------------------------------------------------}

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActAddFavExecute(Sender: TObject);
var
  TmpRom : TQPRom;
begin
  if VTRoms.SelectedCount = 1 then
  begin
      TmpRom := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode));
      FavList.Add(TQPRom.Create(TmpRom.ToString));
      FavList.SaveToFile();
      BuildFavMenu;
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActOrgFavExecute(Sender: TObject);
var
  Fav : TFavForm;
begin
  Fav := TFavForm.Create(self);
  try
  
    If fav.ShowModal = MrOK then
      FavList.SaveToFile
    else
      FavList.LoadFromFile(Settings.FavsFile);

  finally
    FreeAndNil(Fav);
  end;

  BuildFavMenu;
  
end;

{-----------------------------------------------------------------------------}
{                              Folder Actions                                 }
{-----------------------------------------------------------------------------}

procedure TMainFrm.ActDelFolExecute(Sender: TObject);
var
  CurFol : TQPDir;
begin

  CurFol := TQPDir(GetObject(VTDir, VTDir.GetFirstSelected));
  if CurFol <> nil then
  begin

    case CurFol.DirType of
      dtROMs : DelTree(CurFol.FullPath);
      dtSearch : DeleteFile(CurFol.FullPath);
    end;

    ActDelFol.Enabled := False;
    InitTree;
    VTDir.Selected[VTDir.GetFirst] := True;
    VTDir.FocusedNode := VTDir.GetFirst;
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActFolOptExecute(Sender: TObject);
Var
  Opt : TFrmFolder;
  Directory : String;
begin
  //if no nodes are selected then exit the procedure
  if VTDir.FocusedNode = nil then
    exit;

  //set up the directory variable and test to see if its empty
  Directory := GetSelectedFolder;
  If Directory = '' then
    exit;

  Opt := TFrmFolder.Create(self);
  Try
    
    Opt.SelFol := Directory;

    if Opt.ShowModal = mrOK then
      //now refresh the selected directory
      RefreshAll;

  Finally
    FreeAndNil(Opt);
  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActMirrorExecute(Sender: TObject);
Var
  Ini : TMemIniFile;
  OldStyle : Tcursor;
begin

  //check there is a focused directory
  If VTDir.GetFirstSelected <> nil then
  begin

    OldStyle := screen.Cursor;
    Screen.Cursor := crHourGlass;

    VTRoms.BeginUpdate;
    try

      if fileExists(GetSelectedFolder + 'folders.ini') then
      begin
        Ini := TMemIniFile.Create(GetSelectedFolder + 'folders.ini');
        try

          Try
            RomList.MirrorDirectories(Ini);
          except
            on E: EJexception do MessageDlg(E.Message, mtError, [mbOK], 0);
          end;
          
        Finally
          FreeAndNil(Ini);
        end;
      end
      else
        MessageDlg(QP_MIRROR_NOT_ENABLED, mtWarning, [mbOK], 0);

    finally
      Screen.Cursor := OldStyle;
      //Finally Refresh the VTRoms window
      fillroms(GetSelectedTxt);
      VTRoms.EndUpdate;
    End;

  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActNewFolExecute(Sender: TObject);
var
  dir, temp: string;
begin

  //first check that we have a selected parent!
  Dir := GetSelectedFolder;
  if Dir = '' then
    exit;

  //set up the new folder name and path.
  temp := inputbox(QP_MAINFRM_NEW_FOL, QP_MAINFRM_NEW_FOL,'');

  if temp <> '' then
  begin

    Dir := IncludeTrailingPathDelimiter(Dir + Temp);

    if not DirectoryExists(dir) then  //check there are no directories using this name
    Begin
      if not CreateDir(dir) then //create the directory specified.
        raise Exception.Create(QP_CREATE_DIR_FAILED)
      else
      begin
        RefreshAll();
      end;
    end
    Else
      raise Exception.Create(QP_DIRECTORY_ALREADY_EXIST);
  end;

end;

{-----------------------------------------------------------------------------}

{-----------------------------------------------------------------------------}
{                               Help Actions                                  }
{-----------------------------------------------------------------------------}

procedure TMainFrm.ActAboutExecute(Sender: TObject);
var
  About : TAboutBox;
begin
    About := TAboutBox.create(self);
    try
      About.ShowModal;
    finally
      FreeAndNil(About);
    end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActHelpContentsExecute(Sender: TObject);
begin
  If FileExists(Settings.QPDirectory + 'quickplay.chm') then
    ShellExecute(Handle, 'open', PChar(Settings.QPDirectory + 'quickplay.chm'), '', '', sw_Show);
end;

{-----------------------------------------------------------------------------}

{-----------------------------------------------------------------------------}

{-----------------------------------------------------------------------------}
{                               MAME Actions                                  }
{-----------------------------------------------------------------------------}

procedure TMainFrm.ActCatVerExecute(Sender: TObject);
begin
  try
    RomList.SetMameCategories(MainFrm.Settings.SettingsDir);
    VTRoms.Invalidate;
  except
    on E: EJException do MessageDlg(E.Message, mtError, [mbOK], 0);
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActMameRenExecute(Sender: TObject);
var
  Mame : TDatReader;
begin
    Mame := TDatReader.create(self);
    try
      if Mame.ShowModal = mrOk then
        FillRoms(GetSelectedTxt);
    finally
      FreeAndNil(Mame);      
    end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActMergedScanExecute(Sender: TObject);
Var
   MergeFrm : TFrmMAMEMerged;
begin
   MergeFrm := TFrmMAMEMerged.Create(self);
   try
     If MergeFrm.ShowModal = MrOK then
       FillRoms(GetSelectedTxt);
   finally
     FreeAndNil(MergeFrm);
   end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActNPlayersExecute(Sender: TObject);
begin
  try
    RomList.SetMameMultiPlayer(MainFrm.Settings.SettingsDir);
    VTRoms.Invalidate;
  except
    on E: EJException do MessageDlg(E.Message, mtError, [mbOK], 0);
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActOpenCatverExecute(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar('http://www.mameworld.net/catlist'), '', '', sw_Show);
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActOpenNPlayersExecute(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar('http://nplayers.arcadebelgium.be'), '', '', sw_Show);
end;


{-----------------------------------------------------------------------------}
{                               ROM Actions                                   }
{-----------------------------------------------------------------------------}

procedure TMainFrm.ActAddIPSExecute(Sender: TObject);
Var
  IPSFrm : TFrmIPS;
  IPSindex : Integer;
  RData : TQPRom;
begin
  if VTRoms.SelectedCount = 1 then
  begin

      RData := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode));
      IPSFrm := TFrmIPS.Create(self);
      Try

      if IPSFrm.ShowModal = mrOK then
      begin
        //first resize the IPS array for the current ROM
        SetLength(RData.IPS, Length(RData.IPS)+1);
        IPSIndex := High(RData.IPS);
        RData.IPS[IPSIndex].index := IPSIndex;
        RData.IPS[IPSIndex].Name := IPSFrm.Name;
        RData.IPS[IPSIndex].Path := IPSFrm.Path;
      end;
      ROMlist.SaveToFile();

    Finally
      FreeAndNil(IPSFrm);
    end;

  end //end of 1 selected IF statement
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActAddRomExecute(Sender: TObject);
var
  AddRom : TAddRomForm;
begin
    AddRom := TAddRomForm.create(Self);
    try
      AddRom.ShowModal;
    finally
      FreeAndNil(AddRom);
    end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActClearRomsExecute(Sender: TObject);
begin

  if fileexists(GetSelectedTxt) then
    If DeleteFile(GetSelectedTxt) then
      FillRoms(GetSelectedTxt);

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActDelRomExecute(Sender: TObject);
var
    aNode: PVirtualNode;
begin

  // if all the ROMs are selected then call the clear roms function to
  // delete the file itself.
  If VTRoms.SelectedCount = ROMlist.Count then
  begin
    If not ActClearRoms.Execute then
      ShowMessage(QP_MAINFRM_ERROR_CLEARING);
  end
  else //First Check if more than 1 rom is selected.
  if VTRoms.SelectedCount > 0 then
  begin
    //If more than one is selected then pass each selected rom to the delrom procedure
    // this code gets the first selected node and then begins a
    // while loop, getting the next selected node.  when the node
    // is equal to 'nil' - there is no next selected node.

    aNode := VTRoms.GetFirstSelected;
    while aNode <> nil do
    begin
      ROMlist.Remove(TQPRom(GetObject(VTRoms, aNode)));
      aNode := VTRoms.GetNextSelected(aNode);
    end;

    //Save the ROMs file to disk.
    ROMlist.SaveToFile();

    // now delete the nodes in the tree.
    VTRoms.DeleteSelectedNodes;

    // finally we need to update the counts (and actions)
    // this code is taken from the fillROMs function
    if ROMlist.Count > 0 then
    begin
      ActClearRoms.enabled := true;
      StatusBar.simpletext := inttostr(ROMlist.Count) + QP_MAINFRM_FILTER_1 + IntToStr(FFiltered) + QP_MAINFRM_FILTER_2
    end
    else
    begin
      ActClearRoms.enabled := false;
      StatusBar.SimpleText := QP_MAINFRM_NO_ROMS;
    end;
    
  end;

end;

{-----------------------------------------------------------------------------}

//launch Windows Explorer at the location of the Rom
procedure TMainFrm.ActExploreExecute(Sender: TObject);
begin
  If VTRoms.SelectedCount = 1 then
  begin
    try
      TQPROM(GetObject(VTRoms, VTRoms.FocusedNode)).BrowseToROM();
    except
      on E: EJException do MessageDlg(E.Message, mtError, [mbOK], 0);
    end;
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActFileRenameExecute(Sender: TObject);
Var
  RData : TQPRom;
  OldName, newname : String;
begin
    //only execute if a rom is selected in the rom listings
  if VTRoms.FocusedNode <> nil then
  begin

    RData := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode));

    If FileExists(RData.path) = False then
    begin
      MessageDlg(QP_DIRECTORY_NOT_EXIST, mtError, [mbOK], 0);
      Exit;
    end;

    OldName := ExtractFileName(RData.path);

    NewName := OldName;

    If InputQuery(QP_MAINFRM_RENAME_1 + OldName, QP_MAINFRM_RENAME_2 + OldName, NewName) then
    Begin
      try
        RData.RenameFile(NewName);
        ROMList.SaveToFile();
        FilterRoms;
      except
        on E: EJException do MessageDlg(E.Message, mtError, [mbOK], 0);
      end;
    End;

  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActFindRomExecute(Sender: TObject);
var
  Find : TFindForm;
begin
    Find := TFindForm.create(Self);
    try
      find.ShowModal;
      if Find.NewVF then
        RefreshAll();
    finally
      FreeAndNil(find);
    end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActOrphansExecute(Sender: TObject);
begin

  uRomUtils.DeleteAllOrphans();

  FavList.DeleteOrphans();

  FillRoms(GetSelectedTxt);
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActRandomFolderExecute(Sender: TObject);
begin
  //We need to minimise within the UI code now.
  try
    If Settings.MiniOnRun then
      MinimiseQP();
    try
      ROMlist.RunRandom(EmuList);
    finally
      //Restore the minimising if need be.
      If Settings.MiniOnRun then
        RestoreQP();
    end;
  except
    on EJNotice do MainFrm.Close;  //handles the exception raised by running a rom.
    on E: EJException do MessageDlg(E.Message, mtError, [mbOK], 0);
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActRandomAllExecute(Sender: TObject);
begin
  try
    //We need to minimise within the UI code now.
    If Settings.MiniOnRun then
      MinimiseQP();
    try
      uRomUtils.RunRandomAll();
    finally
      //Restore the minimising if need be.
      If Settings.MiniOnRun then
        RestoreQP();
    end;
  except
    on EJNotice do MainFrm.Close;
    on E: EJException do MessageDlg(E.Message, mtError, [mbOK], 0);
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActRomPropExecute(Sender: TObject);
Var
  Prop : TFrmRomProp;
  aNode : PVirtualnode;
begin
  Prop := TFrmRomProp.Create(Self);
  try
    If VTRoms.selectedCount > 0 then
    begin

      //if we are currently editting a rom we need to end that..
      if VTRoms.IsEditing then
        VTRoms.EndEditNode;

      //if there is only 1 emulator selected the user can alter all properties
      if (VTRoms.selectedcount = 1) then
      begin
        Prop.ROM := TQPROM(GetObject(VTRoms, VTRoms.GetFirstSelected));
        Prop.Multi := False;
        Prop.cNode := VTRoms.GetFirstSelected;
      end
      else 
      begin
        Prop.Multi := True;

        // this code gets the first selected node and then begins a
        // while loop, getting the next selected node.  when the node
        // is equal to 'nil' - there is no next selected node.
        aNode := VTRoms.GetFirstSelected;
        while aNode <> nil do
        begin
          Prop.Selected.Add(TQPROM(GetObject(VTRoms, aNode)));
          aNode := VTRoms.GetNextSelected(aNode);
        end;
      end;

      If Prop.ShowModal = mrOK then
      begin
        if VTROMS.SelectedCount = 1 then
          VTROMS.InvalidateNode(VTROMS.GetFirstSelected)
        else
        begin
          //revalidate all selected nodes.
          aNode := VTRoms.GetFirstSelected;
          while aNode <> nil do
          begin
            VTROMS.InvalidateNode(aNode);
            aNode := VTRoms.GetNextSelected(aNode);
          end;
        end;
      end; //end of showmodal
    end;

  finally
    FreeAndNil(Prop);
  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActRunDlgExecute(Sender: TObject);
var
  RDialog : TFrmRunRom;
begin

  //only execute if a rom is selected in the rom listings
  if VTRoms.SelectedCount = 1 then
  begin

    Begin

      Rdialog := TFrmRunRom.Create(Self);
      Try
        RDialog.Rom := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode));
        RDialog.Emu := EmuList.GetEmuForROM(Rdialog.Rom);

        if (RDialog.Emu <> nil) and (RDialog.Rom <> nil) then
          RDialog.ShowModal;

      finally
        FreeAndNil(RDialog);
      end;

    end;
  end;
end;


{-----------------------------------------------------------------------------}

procedure TMainFrm.ActRunRomExecute(Sender: TObject);
var
  RDialog : TFrmRunRom;
  tmpROM : TQPROM;
  tmpEmu : TQPEmu;
begin

  if (VTRoms.SelectedCount = 1) and (VTRoms.FocusedNode <> nil) then
  begin

    If Settings.UseRunDLG then
    Begin

      Rdialog := TFrmRunRom.Create(Self);
      Try

        RDialog.Rom := TQPRom(GetObject(VTRoms, VTRoms.FocusedNode));
        RDialog.Emu := EmuList.GetEmuForROM(RDialog.Rom);

        If (RDialog.Rom <> nil) and (RDialog.Emu <> nil) then
          RDialog.ShowModal;

      finally
        FreeAndNil(RDialog);
      end;
    end

    Else

    Begin
      tmpROM := TQPROM(GetObject(VTRoms, VTRoms.FocusedNode));
      TmpEmu := EmuList.GetEmuForROM(tmpROM);
      RunROM(tmpRom, tmpEmu);
    End;

  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActMultiScanExecute(Sender: TObject);
var
  multi : TRecursiveFrm;
begin
  Multi := TRecursiveFrm.Create(Self);
  try

    Multi.AddToDir := GetSelectedFolder;
    If Multi.ShowModal = mrOK then
      If MainFrm.Active then
        RefreshAll;

  finally
    FreeAndNil(Multi);
  end;
end;

{-----------------------------------------------------------------------------}


procedure TMainFrm.ActScanExecute(Sender: TObject);
var
  Rom : TScanForm;
begin
  VTRoms.BeginUpdate;
  try
  
    Rom := TScanForm.create(Self);
    try
      If Rom.ShowModal = mrOk then
        FillRoms(GetSelectedTxt);
    finally
      FreeAndNil(Rom);
    end;

  finally
    VTRoms.EndUpdate;
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActZipExecute(Sender: TObject);
var
  zip : TFrmzip;
begin
    zip := TFrmZip.create(Self);
    try
      zip.ShowModal;
    finally
      FreeAndNil(zip);
    end;
end;

{-----------------------------------------------------------------------------}
{                             VIEW actions                                    }
{-----------------------------------------------------------------------------}

procedure TMainFrm.ActColumnsExecute(Sender: TObject);
Var
  Col : TFrmColumn;
begin
  Col := TFrmColumn.Create(Self);
  Try
    Col.ShowModal;
  Finally
    FreeAndNil(Col);
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActImgVisibleExecute(Sender: TObject);
begin
  ActImgVisible.Checked := not(ActImgVisible.Checked);
  PanImage.Visible := ActImgVisible.Checked;

  if not Application.Terminated then
    ResetImage();
  
  if ActImgVisible.Checked then
    SPlitImage.Show
  else
    SPlitImage.Hide;
    
end;

{-----------------------------------------------------------------------------}
procedure TMainFrm.ActDBarVisibleExecute(Sender: TObject);
begin
  ActDBarVisible.Checked := not(ActDBarVisible.Checked);
  TBDir.Visible := ActDBarVisible.Checked;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActFilterVisibleExecute(Sender: TObject);
begin
  ActFilterVisible.Checked := not(ActFilterVisible.Checked);
  PanFilter.Visible := ActFilterVisible.Checked;

  //if the filter is being turned off, make sure any stored filters are reset.
  if (not PanFilter.Visible) and (RomList <> nil) and (FFilterString <> '') then
  begin
    TxtFilter.Text := '';
    FFilterString := '';
    FilterRoms;
    StatusBar.SimpleText := inttostr(VTRoms.TotalCount) + QP_MAINFRM_FILTER_1 +
                          IntToStr(FFiltered) + QP_MAINFRM_FILTER_2
  end;
  
  //need to check whether we need the Panel at the top of the ROM list.
  If not PanFilter.Visible and not TBROMs.Visible then
    PanROMtop.Visible := false
  else
    PanROMtop.Visible := true;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActRBarVisibleExecute(Sender: TObject);
begin
  //ActionToolBar1.Visible := ActRomBarVisible.Checked;
  ActRBarVisible.Checked := not(ActRBarVisible.Checked);
  TBRoms.Visible := ActRBarVisible.Checked;

  //need to check whether we need the Panel at the top of the ROM list.
  If not PanFilter.Visible and not TBROMs.Visible then
    PanROMtop.Visible := false
  else
    PanROMtop.Visible := true;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActRefreshExecute(Sender: TObject);
begin
  RefreshAll();
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActSelAllExecute(Sender: TObject);
begin
  //Select all the roms in the listview.
  VTRoms.SelectAll(True);
end;

{-----------------------------------------------------------------------------}
{                              TOOLS options                                  }
{-----------------------------------------------------------------------------}

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActPrefExecute(Sender: TObject);
var
  Pref : TPrefForm;
  ROMfont, DirFont : Integer;
begin
  // save the ini file now, to make sure we get all the changes on disk
  Settings.SaveCosmeticSettings;

  pref := TPrefForm.create(Self);
  try
  
    ROMfont := VTRoms.Font.Size;
    DirFont := VTDir.Font.Size;
    if pref.ShowModal = mrOK then
    begin

      If (ROMfont <> VTRoms.Font.Size) or (DirFont <> VTDir.Font.Size) then
        RefreshAll();

      SetDirImage();

    end;

  finally
    FreeAndNil(pref);
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActBackupRestoreExecute(Sender: TObject);
var
  Backup : TFrmBackup;
begin
  Backup := TFrmBackup.Create(Self);
  Try
    if Backup.ShowModal = MrOK then
      RefreshAll();
  Finally
    FreeAndNil(Backup);
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActCustomDataExecute(Sender: TObject);
var
  Custom : TFrmROMData;
begin
  Custom := TFrmROMData.Create(self);
  try

    Custom.ShowModal;

  Finally
    FreeAndNil(Custom);
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ActResetConfigExecute(Sender: TObject);
var
  Wiz : TFrmWelcome;
begin

  if MessageDlg(QP_SETTINGS_RESET_CFG, mtWarning, [mbYes,mbNo], 0) in [mrYes] then
  begin

    VTRoms.Clear;
    VTDir.Clear;

    EmuList.Clear;
    ROMlist.Clear;
    //FavList.ClearFavs;

    if DirectoryExists(Settings.SettingsDir) then
      DelTree(Settings.SettingsDir);
    if DirectoryExists(Settings.ROMsDir) then
      DelTree(Settings.ROMsDir);

    Settings.PathSetup;
    Settings.LoadIni;

    
    Wiz := TFrmWelcome.Create(Self);
    try
      Wiz.ShowModal;
    Finally
      FreeAndNil(Wiz);
    end;

    RefreshAll;

  end; //end of MessageDlg IF
  
end;

{-----------------------------------------------------------------------------}
{                              Other published code                           }
{-----------------------------------------------------------------------------}

procedure TMainFrm.FavClick(Sender : TObject);
var
  mnu : TMenuItem;
begin
  //dont delete
  mnu := sender as TMenuItem;
  RunROM(FavList[mnu.tag], EmuList.GetEmuForROM(FavList[mnu.tag]));
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.FocusChangeRoms(NewFol : TQPDir; NewNode : PVirtualNode);
var
  Ini : TMemIniFile;
  BGPath : String;
begin
  //start of directory listing code.
  Ini := TMemIniFile.Create(NewFol.FullPath + 'folders.ini');
  Try

    //get the filter function type
    FFilterByStart := Ini.ReadBool('Filter', 'ByStart', true);
    Settings.HideShowCol(NewFol.FullPath);

    //set the background
    //initially turn off the background.
    VTRoms.TreeOptions.PaintOptions := VTRoms.TreeOptions.PaintOptions - [toShowBackground];
    //now do checking to see if a valid background has been chosen.
    if ini.ReadBool('BkGround', 'ChkBk', false) then
    Begin
      BGpath := Ini.ReadString('BkGround', 'TxtBKPath', '');
      if (BGpath <> '') and (FileExists(BGpath) ) then
      begin
        VTRoms.Background.LoadFromFile(BGpath);
        VTRoms.TreeOptions.PaintOptions := VTRoms.TreeOptions.PaintOptions + [toShowBackground]
      end
    end;

    //related to Real Icon support
    ROMIcons.Clear;
    FRealIconDir := Ini.ReadString('RealIcon', 'Directory', '');
    If (FRealIconDir <> '') and (DirectoryExists(FRealIconDir)) then
      RealIconOn := Ini.ReadBool('RealIcon', 'ChkRealIcons', false)
    else
    begin
      RealIconOn := False;
      FRealIconDir := '';
    end;

    If Settings.UseImagesForROMs and RealIconOn then
    Begin
      VTRoms.Images := ROMicons;

      If Ini.ReadBool('RealIcon', 'ChkLargeIcons', false) then
      begin
        SetROMHeight(32);
        ROMIcons.Width := 32;
        ROMIcons.Height := 32;
      end
      else
      begin
        SetROMHeight(20);
        ROMIcons.Width := 16;
        ROMIcons.Height := 16;
      end;
            
    end
    else
    begin
      VTRoms.Images := ImageList1;
      SetROMHeight(20);
    end;

  Finally
    FreeAndNil(Ini);
  end;

  fillroms(NewFol.FullPath+DefaultFileName);

  //enable the actions now
  ActNewFol.Enabled := true;
  ActMirror.Enabled := true;
  ActScan.enabled := true;
  ActAddRom.Enabled := True;
  ActMultiScan.Enabled := True;
  ActFolOpt.Enabled := true;
      
  If VTDir.GetNodeLevel(NewNode) = 0 then
    ActDelFol.enabled := False
  else
    ActDelFol.enabled := True;

  //end of directory listing code.
end;
{-----------------------------------------------------------------------------}

procedure TMainFrm.FocusChangeSearch(NewFol : TQPDir; NewNode : PVirtualNode);
var
  InQuery : TStringList;
  Querys : TObjectList;
  QueryResults, TmpList : TQPRomList;
  MatchAll : Boolean;
  i, e : Integer;
begin
  if FileExists(Settings.QPDirectory+'find.png') then
  begin
    VTRoms.Background.LoadFromFile(Settings.QPDirectory+'find.png');
    VTRoms.TreeOptions.PaintOptions := VTRoms.TreeOptions.PaintOptions + [toShowBackground]
  end
  else
    VTRoms.TreeOptions.PaintOptions := VTRoms.TreeOptions.PaintOptions - [toShowBackground];

  VTRoms.Clear;
  VTRoms.RootNodeCount := 0;
  VTRoms.Images := ImageList1;
  SetROMHeight(20);
  ROMIcons.Width := 16;
  ROMIcons.Height := 16;
  RealIconOn := False;
  FRealIconDir := '';

  //setup the columsn
  Settings.HideShowCol('');

  if VTDir.GetNodeLevel(NewNode) > 0 then
  begin
    //load the query and execute it!
    InQuery := TStringList.Create();
    try
      Querys := TObjectList.Create(True);
      InQuery.LoadFromFile(NewFol.FullPath);
      MatchAll := StrToBool(InQuery[0]);
      for i := 1 to InQuery.Count-1 do
        Querys.Add(TQPQuery.create(InQuery[i]));
      //now we have the querys objectlist set up with our query.
      QueryResults := TQPRomList.Create(Settings.AllowWrite);
      TmpList := TQPROmList.Create(Settings.AllowWrite);
      Try

        //reuse the stringlist from above to hold all possible rom files.
        GetAllROMFiles(InQuery);
        for i := 0 to InQuery.Count-1 do
        begin
          TmpList.LoadMatchesFromFile(inQuery[i], Querys, MatchAll);
          for e := 0 to TmpList.Count-1 do

            if TmpList[e].MatchesQuery(Querys, MatchAll) then
            begin
              QueryResults.Add(TQPROM.create());
              QueryResults.last.Assign(TmpList[e]);
            end;
          //free whats in the ROMs array
          TmpList.clear;
        end;

        //ok now queryresults is full of roms that match.  save teh file and then load it..
        QueryResults.FileName := ChangeFileExt(NewFol.FullPath, '.tmp');
        QueryResults.SaveToFile;
        fillroms(ChangeFileExt(NewFol.FullPath, '.tmp'));
            
      Finally
        FreeAndNil(QueryResults);
        FreeAndNil(TmpList);
      end;
    finally
      FreeAndNil(InQuery);
      FreeAndNil(Querys);
    end;
  end;

  //set up the actions so we cant scan or add items.
  If VTDir.GetNodeLevel(NewNode) = 0 then
    ActDelFol.enabled := False
  else
    ActDelFol.enabled := True;
  ActScan.enabled := false;
  ActMultiScan.Enabled := False;
  ActAddRom.Enabled := False;
  ActAddRom.enabled := false;
  ActMirror.Enabled := false;
  ActFolOpt.Enabled := false;

end;

procedure TMainFrm.FormCreate(Sender: TObject);
var
  WizardFrm : TFrmWelcome;
begin
  //MemCheckLogFileName := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0))) + 'memcheck.txt';
  //MemChk;

  //create the zip object.
  uJZip.CreateZip();

  //set the hint timings to be used.
  Application.HintPause := 750;
  Application.HintShortPause := 100;
  Application.HintHidePause := 3200;

  {$IFDEF DEBUG}
  AddToLog('QuickPlay STARTING');
  {$ENDIF}

  Settings := TQPSettings.Create;
  SystemList := TObjectList.Create(True);
  EmuList := TQPEmuList.Create(Settings.SettingsDir+'emulators.ini', Settings.AllowWrite);
  RomList := TQPRomList.Create(Settings.AllowWrite);
  FavList := TQPRomList.Create(Settings.AllowWrite);

  SetDirImage();
  
  //load the available emulators
  EmuList.LoadFromFile();

  //create the objectlist to store our objects for the VTDir
  DirList := TObjectList.Create(True);

  {$IFDEF DEBUG}
  AddToLog('All Objects Created Successfully');
  {$ENDIF}

  //now set up our Virtual Treeviews with their 'sizeOfs'
  VTRoms.NodeDataSize := SizeOf(Pointer);
  VTDir.NodeDataSize := SizeOf(Pointer);
  VTEmus.NodeDataSize := SizeOf(Pointer);

  MainFrm.Caption := MainFrm.Caption + ' ' + QPver;

  ResetImage();

  If Settings.NoDats then
  begin
    WizardFrm := TFrmWelcome.Create(Self);
    Try
      WizardFrm.ShowModal;
    Finally
      FreeAndNil(WizardFrm);
    end;
  end;

  init();

  Settings.LoadLastROM;

  //set up the Emulators Tree
  InitEmuTree();

  pgSideBar.ActivePageIndex := 0;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  {$IFDEF DEBUG}
  AddToLog('QuickPlay is about to shutdown');
  {$ENDIF}

  VTRoms.EndEditNode();

  //kill any hints.  yes this is done because im paranoid about shutdown code!
  Application.CancelHint;

  if (GetSelectedFolder <> '') and (VTRoms.GetFirstSelected <> nil) then
    Settings.SaveCurrentROM(GetSelectedFolder, GetObject(VTRoms, VTRoms.GetFirstSelected));
  
  //wipe all the treeviews
 { VTMedia.Clear;
  VTRoms.Clear;
  VTDir.Clear;
  MediaFound.Clear;}
  
  // clear image list related stuff.
  EmuFolders.Clear;
  ROMIcons.Clear;

  //clear all our dynamic menus (IPS, Favs, RunWith)
  ClearAllDynMenus;

  {$IFDEF DEBUG}
  AddToLog('Interface elements have been cleared');
  {$ENDIF}

  //now save the current settings.
  Settings.SaveCosmeticSettings;

  {$IFDEF DEBUG}
  AddToLog('Settings Saved.');
  {$ENDIF}

  {$IFDEF DEBUG}
  AddToLog('Object Cleanup code executed, preparing to FreeAndNil');
  {$ENDIF}

  //Free the Quickplay objects we have created.
  DirList.Clear;
  ROMlist.Clear;
  FavList.Clear;
  EmuList.Clear;
  SystemList.Clear;

  uJZip.DestroyZip();

  DirList.Free;
  RomList.Free;
  FavList.Free;
  EmuList.Free;
  Settings.Free;
  SystemList.Free;

  {$IFDEF DEBUG}
  AddToLog('QuickPlay SHUTDOWN');
  AddToLog('-----------------------------------------------------------------');
  {$ENDIF}

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.RomPopUpPopup(Sender: TObject);
begin
  PopMenuBuild();
  PopmenuIPS();
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.RunWithClick(Sender: TObject);
begin
  //For Some reason this keeps losing its association!!!  V.Annoying!
end;

procedure TMainFrm.IPSMenuClick(Sender: TObject);
begin
  //For Some reason this keeps losing its association!!!  V.Annoying!
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.TxtFilterKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  FFilterString := TxtFilter.Text;
  FilterRoms;
  StatusBar.SimpleText := inttostr(VTRoms.TotalCount) + QP_MAINFRM_FILTER_1 +
                          IntToStr(FFiltered) + QP_MAINFRM_FILTER_2
end;

{-------------- start of code for VTRoms treeview -------------------}

procedure TMainFrm.VTRomsGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  ROM : TQPRom;
  Emu : TQPEmu;
  Comment : String;
begin
{the columns are as follows:
 0-name
 1-GameType
 2-Path
 3-Emulator
 4-System
 5-Year
 6-Number of times played
 7-Language
 8-Rating
 9-Parameters
 10-number of IPS associated
 11-Company
 12-Comment
}
  // A handler for the OnGetText event is always needed as it provides the tree with the string data to display.
  // Note that we are always using WideString.
  if Node = nil then
    exit;

  ROM := TQPRom(GetObject(Sender, Node));

  If ROM = nil then
    exit;

  Emu := EmuList.GetEmuForROM(Rom);

      Case Column of
        0:  If VTRoms.Header.Columns.Items[0].Options >= [coVisible] then
              CellText := ROM.name;
        1:  If VTRoms.Header.Columns.Items[1].Options >= [coVisible] then
              CellText := ROM.GameType;
        2:  If VTRoms.Header.Columns.Items[2].Options >= [coVisible] then
              CellText := ROM.path;
        3:  If VTRoms.Header.Columns.Items[3].Options >= [coVisible] then
              If (Settings.AddVersion) and
                 (Emu <> nil) and
                 (Emu.Version <> '') then
                CellText := ROM.emulator+' ('+Emu.Version+')'
              else
                CellText := ROM.emulator;
        4:  If VTRoms.Header.Columns.Items[4].Options >= [coVisible] then
            Begin
              if Emu <> nil then
                CellText := Emu.system
              else
                CellText := QP_UNKNOWN;
            end;

        5:  If VTRoms.Header.Columns.Items[5].Options >= [coVisible] then
              CellText := ROM.Year;
        6:  If VTRoms.Header.Columns.Items[6].Options >= [coVisible] then
              CellText := IntToStr(ROM.numPlay);
        7:  If VTRoms.Header.Columns.Items[7].Options >= [coVisible] then
              CellText := ROM.Language;
        8:  If VTRoms.Header.Columns.Items[8].Options >= [coVisible] then
              CellText := ROM.Rating;
        9:  If VTRoms.Header.Columns.Items[9].Options >= [coVisible] then
              CellText := ROM.Parameters;
        10: If VTRoms.Header.Columns.Items[10].Options >= [coVisible] then
              CellText := IntToStr(Length(ROM.IPS));
        11: If VTRoms.Header.Columns.Items[11].Options >= [coVisible] then
              CellText := ROM.Company;
        12: If VTRoms.Header.Columns.Items[12].Options >= [coVisible] then
            begin
              Comment := ROM.Comment;
              StrReplace(Comment, chr(13)+chr(10), ' ', [rfReplaceAll]);
              CellText := Comment;
            end;
        13: If VTRoms.Header.Columns.Items[13].Options >= [coVisible] then
              CellText := ROM.Multiplayer;
        end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
Var
  Find : ThhFindFile;
  RomName : String;
  NewIcon : TIcon;
  ROM : TQPROM;
begin

  if (Node <> nil) and (Settings.UseImagesForROMs = true) and (Kind in [ikNormal, ikSelected]) and (Column = 0) then
  begin

    ROM := TQPRom(GetObject(Sender, Node));

    If (RealIconOn) and (FRealIconDir <> '') and (DirectoryExists(FRealIconDir)) then
    Begin

      //now check that the imagelist isnt bigger than the ROMS array
      If ROMIcons.Count > ROMlist.Count then
        ClearROMIcons;

      if ROM.IconIndex <> -1 then
      Begin
        ImageIndex := ROM.IconIndex;
        exit;
      end;

      If ROM.CloneName <> '' then
        ROMName := ROM.CloneName
      else
        RomName := ChangeFileExt(ExtractFileName(ROM.path), '');

      Find := ThhFindFile.Create(Self);
      Try
        Find.Directory := FRealIconDir;
        Find.Recurse := False;
        Find.Filter := RomName+'.ico';
        Find.Execute;
        If Find.TotalFile = 1 then
        Begin

          NewIcon := TIcon.Create;
          try

            NewIcon.LoadFromFile(Find.Files[0]);
            ROM.IconIndex := ROMIcons.AddIcon(NewIcon);
            ImageIndex := ROM.IconIndex;
          finally
            FreeAndNil(NewIcon);
          end;

        end
        else //assign the default
        begin
          ROM.IconIndex := 0;
          ImageIndex := 0;
        end;

        Finally
          FreeAndNil(Find);
        end;

      end

      else
      begin
        if ROM.Exists = -1 then
          if (FileExists(ROM.path)) or ( (ROM.CloneName <> '') and (DirectoryExists(ExtractFilePath(ROM.Path))) ) then
            ROM.Exists := 1
          else
            ROM.Exists := 0;

        if ROM.Exists = 1 then
          ImageIndex := 20
        else
          ImageIndex := 21;
      end;

  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsChange(Sender: TBaseVirtualTree;
  Node: PVirtualNode);
Var
  Find : ThhFindFile;
  i, e, last : Integer;
  Ini : TMemIniFile;
  BinPath : TMemoryStream;
  Path : TStrings;
  ROM : TQPRom;
  RPath : String;
  ImagesFound, MiscFound : TStringList;
  myIcon : TIcon;
  myStream : TMemoryStream;
begin

  //check to see if the application is terminating, if so exit

  ResetImage();

  If (PanImage.Visible) and (VTRoms.RootNodeCount > 0) and (Node <> nil)
     and (VTRoms.SelectedCount = 1) then
  Begin

    ROM := TQPRom(GetObject(Sender, Node));
    RPath := ROM.Path;

    if GetSelectedFolder = '' then
      exit;

    Find := ThhFindFile.Create(Self);

    Try
      //turn off searching of sub-dirs
      Find.Recurse := False;

      If ROM.CloneName <> '' then
      begin
        if (Settings.ParentsForClones) and (ROM.ParentName <> '') then
          Find.Filter := ROM.ParentName
        else
          Find.Filter := ROM.CloneName;
      end
      else
        Find.Filter := ChangeFileExt(ExtractFileName(RPath), '');

      //Filter is the name of the rom
      // 1 - must match all
      // 2 - must start with rom name
      // 3 - must include rom name
      Case Settings.SearchType of
        1: Find.Filter := Find.Filter+'.*';
        2: Find.Filter := Find.Filter+'*.*';
        3: Find.Filter := '*' + Find.Filter + '*.*';
      end;

      //create the objects needed for searching all media paths
      Ini := nil;
      BinPath := nil;
      Path := TStringList.Create;
      Try
        Ini := TMemIniFile.Create(GetSelectedFolder + 'folders.ini');
        BinPath := TMemoryStream.Create;

        //load the paths in from the binary stream they are stored as
        Ini.ReadBinaryStream('MediaPaths', 'LstPaths', BinPath);
        Path.LoadFromStream(BinPath);
        //if the setting to search in the rom dir is on, add the rom dir
        If Settings.SearchROMDir then
          Path.Add(ExtractFilePath(RPath));

        //now create a stringlist to hold the search results
        ImagesFound := TStringList.Create;
        try
          MiscFound := TStringList.Create;
        
          For I := 0 to Path.Count-1 do
          Begin

            //Do a search for every directory in the folder options
            Find.Directory := Path.Strings[i];
            Find.Execute;

            //make sure we havent included the actual ROM.path
            For e := 0 to Find.TotalFile-1 do
              if StrCompare(Find.Files[e], RPath)<>0 then
                ImagesFound.Add(Find.files[e])
                
          End;  //end of FOR Loop i to Path.count-1

          //now iterate through all items in the media panel and move non-images to misc!
          For i := ImagesFound.Count-1 downto 0 do
          begin
            //if its not an image then move it to the MiscFound stringlist
            if not ujFile.FileIsImage(ImagesFound[i]) then
            begin
              MiscFound.Add(ImagesFound[i]);
              ImagesFound.Delete(i);
            end;
          end;

          if (ImagesFound.Count = 1) and (MiscFound.Count = 0) then
          begin
            //theres only ONE image, display this.
            ImgRom.Picture.LoadFromFile(ImagesFound[0]);
            jvThumb.Hide;
            ImgROM.Show;
          end
          else if (ImagesFound.Count > 1) or (MiscFound.Count > 0) then
          begin
            jvThumb.ThumbList.BeginUpdate;
            try
              for i := 0 to ImagesFound.Count-1 do
                jvThumb.AddFromFile(ImagesFound[i]);

              myIcon := TIcon.Create;
              try
                myStream := TMemoryStream.Create;
                //now add all the misc found items.
                for i := 0 to MiscFound.Count-1 do
                begin
                  //its not an image, give me a associated icon.
                  if GetEXEIcon(myIcon, MiscFound[i]) then
                  begin
                    myIcon.SaveToStream(myStream);
                    myStream.Position := 0;
                    jvThumb.AddThumb(ExtractFileName(MiscFound[i]), False);
                    last := jvThumb.ThumbList.IndexOf(ExtractFileName(MiscFound[i]));
                    //this will fail because its not a picture
                    try
                      jvThumb.ThumbList[last].FileName := MiscFound[i];
                    except
                    end;
                    jvThumb.ThumbList[last].Photo.LoadFromStream(myStream, grIco);
                    myStream.Clear;
                    jvThumb.Refresh;
                  end;
                end;//end of Loop through MiscFound
              finally
                FreeAndNil(myStream);
                FreeAndNil(myIcon);
              end;

              jvThumb.SortList;
            finally
              //always make sure endupdate is called.
              jvThumb.ThumbList.EndUpdate;
            end;
            ImgROM.Hide;
            jvThumb.Show;
          end;

        finally
          FreeAndNil(MiscFound);
          FreeAndNil(ImagesFound);
        end;

      Finally
        FreeAndNil(Ini);
        FreeAndNil(BinPath);
        FreeAndNil(Path);
      end;

    Finally
      FreeAndNil(Find);
    end;

  End;    
     
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsHeaderClick(Sender: TVTHeader;
  Column: TColumnIndex; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if Button = mbLeft then
  begin
    with Sender, Treeview do
    begin
      if SortColumn > NoColumn then
        Columns[SortColumn].Options := Columns[SortColumn].Options + [coParentColor];
        
        if (SortColumn = NoColumn) or (SortColumn <> Column) then
        begin
          SortColumn := Column;
          SortDirection := sdAscending;
        end
        else
          if SortDirection = sdAscending then
            SortDirection := sdDescending
          else
            SortDirection := sdAscending;

        SortTree(SortColumn, SortDirection, False);
    end;
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsIncrementalSearch(Sender: TBaseVirtualTree;
  Node: PVirtualNode; const SearchText: WideString; var Result: Integer);
      function Min(const A, B: Integer): Integer;  {save us linking in math.pas}
      begin
        if A < B then
          Result := A
        else
          Result := B;
      end;
var
  sCompare1, sCompare2 : string;
  DisplayText : WideString;

begin
     VTRoms.IncrementalSearchDirection := sdForward;
     // Note: This code requires a proper Unicode/WideString comparation routine which I did not want to link here for
     // size and clarity reasons. For now strings are (implicitely) converted to ANSI to make the comparation work.
     // Search is not case sensitive.
      VTRomsGetText( Sender, Node, 0 {Column}, ttNormal, DisplayText );
      sCompare1 := SearchText;
      sCompare2 := DisplayText;

     // By using StrLIComp we can specify a maximum length to compare. This allows us to find also nodes
     // which match only partially. Don't forget to specify the shorter string length as search length.
     Result := StrLIComp( pchar(sCompare1), pchar(sCompare2), Min(Length(sCompare1), Length(sCompare2)) )

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsFreeNode(Sender: TBaseVirtualTree;
  Node: PVirtualNode);
begin
  // I have NO idea if this is what im supposed to do at this point, do it anyway...
  SetObject(Sender, Node,  nil);
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsGetHint(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  ROM : TQPRom;
begin
  //if the node is nil then exit and dont do anything.
  If Node <>  nil then
  begin
    ROM := TQPRom(GetObject(Sender, Node));

    If ROM <> nil then
      //displays the hint for the ROM list.  Should maybe make this an option
      CellText := ROM.Summary;
  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsCompareNodes(Sender: TBaseVirtualTree; Node1,
  Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
var
  sys1, sys2 : TQPEmu;
  ROM1, ROM2 : TQPROM;
begin
{0-name
 1-GameType
 2-Path
 3-Emulator
 4-System
 6-Number of times played
 7-Language
 8-Rating
 9-Parameters
 10-number of IPS associated
 11-Company
 12-Comment
 13-Players}
  ROM1 := TQPRom(GetObject(Sender, Node1));
  ROM2 := TQPRom(GetObject(Sender, Node2));

  begin
  case Column of

    0:Result := CompareText(ROM1.name, ROM2.name);
    1:Result := CompareText(ROM1.GameType, ROM2.GameType);
    2:Result := CompareText(ROM1.path, ROM2.path);
    3:Result := CompareText(ROM1.emulator, ROM2.emulator);
    4:Begin
      Sys1 := EmuList.GetEmuForROM(ROM1);
      Sys2 := EmuList.GetEmuForROM(ROM2);
      if (Sys1 <> nil) and (Sys2 <> nil) then
        Result := CompareText(Sys1.System, Sys2.System);
      end;
    5:Result := CompareText(ROM1.Year, ROM2.Year);
    6:Result := ROM1.NumPlay - ROM2.NumPlay;
    7:Result := CompareText(ROM1.Language, ROM2.Language);
    8:Result := CompareText(ROM1.Rating, ROM2.Rating);
    9:Result := CompareText(ROM1.Parameters, ROM2.Parameters);
    10:Result := (length(ROM1.IPS))-(length(ROM2.IPS));
    11:Result := CompareText(ROM1.Company, ROM2.Company);
    12:Result := CompareText(ROM1.Comment, ROM2.Comment);
    13:Result := CompareText(Rom1.Multiplayer, ROM2.Multiplayer);
  end;
  end;//end of WITH block

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  If (VTRoms.FocusedNode <> nil) then
  begin
    case key of
      VK_DELETE : ActDelROM.Execute;
      VK_RETURN : begin
                    if (VTROMS.IsEditing) then
                    begin
                      VTROMS.EndEditNode;
                      VTROMS.SetFocus;
                    end
                    else
                      ActRunROM.Execute
                  end;
    end;

  end;

  Case key of
    VK_Home : begin
                VTRoms.Selected[VTRoms.GetFirst()] := True;
                VTRoms.FocusedNode := VTRoms.GetFirst;
              end;
    VK_End :  begin
                VTRoms.Selected[VTRoms.GetLast()] := True;
                VTRoms.FocusedNode := VTRoms.GetLast;
              end;
  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsEditing(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; var Allowed: Boolean);
begin
  {0-name
 1-GameType
 2-Path
 3-Emulator
 4-System
 5- year
 6-Number of times played
 7-Language
 8-Rating
 9-Parameters
 10-number of IPS associated
 11-Company
 12-Comment
 13-Players}
  If (TQPDir(GetObject(VTDir, VTDir.FocusedNode)).DirType = dtROMs) and
     (Column in [0, 1, 2, 3, 5, 7, 8, 9, 11, 12, 13]) then
    Allowed := True
  else
    Allowed := False;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsExit(Sender: TObject);
begin
  if VTRoms.IsEditing then
    VTRoms.EndEditNode;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsNewText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; NewText: WideString);
begin
  If (Node <> nil) then
  begin

    case Column of
      0 : If NewText <> '' then
            TQPRom(GetObject(Sender,Node)).Name := NewText;
      1 : TQPRom(GetObject(Sender,Node)).GameType := NewText;
      2 : If NewText <> '' then
            TQPRom(GetObject(Sender,Node)).Path := NewText;
      3 : TQPRom(GetObject(Sender,Node)).Emulator := NewText;
      5 : TQPRom(GetObject(Sender,Node)).Year := NewText;
      7 : TQPRom(GetObject(Sender,Node)).Language := NewText;
      8 : TQPRom(GetObject(Sender,Node)).Rating := NewText;
      9 : TQPRom(GetObject(Sender,Node)).Parameters := NewText;
      11: TQPRom(GetObject(Sender,Node)).Company := NewText;
      12: TQPRom(GetObject(Sender,Node)).Comment := NewText;
      13: TQPRom(GetObject(Sender, Node)).Multiplayer := NewText;      
    end;

    ROMlist.SaveToFile();
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTRomsCreateEditor(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; out EditLink: IVTEditLink);
begin
{0-name
 1-GameType
 2-Path
 3-Emulator
 4-System
 5-year
 6-Number of times played
 7-Language
 8-Rating
 9-Parameters
 10-number of IPS associated
 11-Company
 12-Comment
 13-Players}
  Case Column of
    0:  EditLink := TQPVTEdit.Create(qpeEdit);
    1:  EditLink := TQPVTEdit.Create(qpeComboType);
    2:  EditLink := TQPVTEdit.Create(qpeFileEdit);
    3:  EditLink := TQPVTEdit.Create(qpeComboEmu);
    5:  EditLink := TQPVTEdit.Create(qpeEdit);
    7:  EditLink := TQPVTEdit.Create(qpeComboLang);
    8:  EditLink := TQPVTEdit.Create(qpeComboRating);
    9:  EditLink := TQPVTEdit.Create(qpeEdit);
    11: EditLink := TQPVTEdit.Create(qpeEdit);
    12: EditLink := TQPVTEdit.Create(qpeEdit);
    13: EditLink := TQPVTEdit.Create(qpeEdit);
  end;
end;

{------------- end of code for VTRoms treeview ------------------------}

{------------------------start of code for virtual directory tree ------}

procedure TMainFrm.VTdirInitNode(Sender: TBaseVirtualTree; ParentNode,
  Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
var
  CurFol : TQPDir;
begin
  //this code initialises the VTdir Treeview nodes
  
  //first check if its a root node.
  if ParentNode = nil then
  begin
    SetObject(Sender, Node, DirList[Node.Index]);

    //now we determine if its the directory node, or the emulator node
    case TQPDir(DirList[Node.Index]).DirType of
      dtROMs : Include(InitialStates, ivsExpanded);
      dtSearch : begin
                   Include(InitialStates, ivsHasChildren);
                   Include(InitialStates, ivsExpanded);
                 end;
    end;

    Sender.NodeHeight[Node] := FDirHeight;
  //end of root node initialisation
  end;

  CurFol := TQPDir(GetObject(Sender, Node));

  //for the directory listing we want it expanded.
  if (CurFol.DirType = dtROMs) and HasSubDirs(CurFol.FullPath) then
    Include(InitialStates, ivsHasChildren);

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirInitChildren(Sender: TBaseVirtualTree;
  Node: PVirtualNode; var ChildCount: Cardinal);
var
  CurFol : TQPDir;
  OldStyle : TCursor;
begin

  CurFol := TQPDir(GetObject(Sender, Node));
  //first point to consider, there are 3 parts of this tree
  //part 1 - the directory listing
  //part 2 - The Virtual Folders
  //part 3 - the 'open' emulator filtering.
  //so check for this by checking the value of emu.
  OldStyle := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  VTDir.BeginUpdate;
  try
    case CurFol.DirType of
      dtROMs: ChildCount := InitialiseDirectory(CurFol, Node);
      dtSearch: ChildCount := InitialiseSearch(CurFol, Node);
    end;//end of CASE statement

    ChildCount := Sender.ChildCount[Node];

    // finally sort node
    if ChildCount > 0 then
      Sender.Sort(Node, 0, TVirtualStringTree(Sender).Header.SortDirection, False);
  finally
    VTDir.EndUpdate;
    Screen.Cursor := OldStyle;
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
var
  CurFol : TQPDir;
begin
  If Node = nil then
    exit;

  CurFol := TQPDir(GetObject(Sender, Node));

  If not CurFol.CustomIcon then
  begin
    case Kind of
      ikNormal: ImageIndex := CurFol.NormalIcon;
      ikSelected: ImageIndex := CurFol.SelIcon;
    end;
  end
  else
  begin
    case Kind of
      ikState:ImageIndex := CurFol.NormalIcon;
    end;
  end;
  
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
begin
  if node = nil then
    exit;

  //the only data output is the display for each node so no case statements needed
  CellText := TQPDir(GetObject(Sender, Node)).DisplayText;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirFreeNode(Sender: TBaseVirtualTree;
  Node: PVirtualNode);
begin
  // I have NO idea if this is what im supposed to do at this point, do it anyway...
  SetObject(Sender, Node,  nil);
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirGetHint(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
Var
  CurFol : TQPDir;
begin
  // this procedure draws the item node hint on mouseover.
  // for directories - show the directory.
  // for systems, umm do nothing?
  // for emulators - show a custom message

  CurFol := TQPDir(GetObject(Sender, Node));
  if CurFol.DirType = dtROMs then
    // this is a directory so show the directory path
    CellText := CurFol.FullPath
  else
  begin
    if (Sender.GetNodeLevel(Node) > 1) then
      CellText := QP_MAINFRM_DBLCLICK + #13#13 +
                  CurFol.DisplayText + #13 +
                  CurFol.FullPath;

  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirFocusChanging(Sender: TBaseVirtualTree; OldNode,
  NewNode: PVirtualNode; OldColumn, NewColumn: TColumnIndex;
  var Allowed: Boolean);
Var
  CurFol : TQPDir;
  OldStyle : TCursor;
begin
  Allowed := (OldNode <> NewNode);
  If (Allowed) and (NewNode <> nil) then
  begin
    //this code is called whenever the user changes the selected directory

    CurFol := TQPDir(GetObject(Sender, NewNode));

    If CurFol <> nil then
    begin

      If Settings.ClearFilter then
      begin
        TxtFilter.Text := '';
        FFilterString := '';
      end;

      OldStyle := Screen.Cursor;
      Screen.Cursor := crHourGlass;
      try
        //first of all i want to test if this is a directory listing folder.
        Case CurFol.DirType of
          dtROMS: FocusChangeROMs(CurFol, NewNode);
          dtSearch: FocusChangeSearch(CurFol, NewNode);
        end;

        ResetImage();
        
      finally
        Screen.Cursor := OldStyle;
      end;
    end;
  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirGetPopupMenu(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; const P: TPoint;
  var AskParent: Boolean; var PopupMenu: TPopupMenu);
var
  CurFol : TQPDir;
begin

  PopupMenu := nil;
  
  If Node <> nil then
  begin
    //this procedure makes sure that the VTdir popup only appears for folders
    CurFol := TQPDir(GetObject(Sender,Node));
    //if the node is a root node we dont want a pop up
    //if the node is a emulator filter we dont want a pop up.
    if CurFol.DirType = dtROMs then
      //make the popup access the directory view popup
      PopupMenu := DirPopUp;
  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirCompareNodes(Sender: TBaseVirtualTree; Node1,
  Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
var
  Dir1, Dir2 : TQPDir;
begin
  Dir1 := TQPDir(GetObject(Sender, Node1));
  Dir2 := TQPDir(GetObject(Sender, Node2));
  // folder are always before files
  if Dir1.DirType <> Dir2.DirType then
  begin
    // one of both is a folder the other a file
    if Dir1.DirType = dtROMs then
      Result := -1
    else
      Result := 1;
  end
  else // both are of same type (folder or file)
    Result := CompareText(Dir1.DisplayText, Dir2.DisplayText);

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirDragDrop(Sender: TBaseVirtualTree;
  Source: TObject; DataObject: IDataObject; Formats: TFormatArray;
  Shift: TShiftState; Pt: TPoint; var Effect: Integer; Mode: TDropMode);
var
  DropNode, rNode : PVirtualNode;
  DropFol : TQPDir;
  Txtfile : String;
  TmpRoms, TmpList : TQPROMlist;
  I, NewIndex : integer;
begin

  if DataObject = nil then
  begin
    // VCL drag'n drop. 
    if Source = VTRoms then
    begin

      VTRoms.BeginUpdate;

      DropNode := VTdir.GetNodeAt(pt.X,Pt.Y);
      DropFol := TQPDir(GetObject(VTdir, DropNode));
      if (DropNode = nil) or (DropFol.DirType <> dtROMs) then
        exit;

      Effect := DROPEFFECT_COPY;
      TxtFile := DropFol.FullPath + DefaultFileName;

      TmpRoms := TQPROMlist.Create(Settings.AllowWrite);
      TmpList := TQPROMlist.Create(Settings.AllowWrite);

      //get all the selected nodes from the VTRoms and store them temporarily
      rNode := VTRoms.GetFirstSelected;

      while rNode <> nil do
      begin
        NewIndex := TmpRoms.Add(TQPRom.Create);
        TmpRoms[NewIndex].Assign(TQPRom(GetObject(VTRoms, rNode)));
        ROMlist.Remove(TQPRom(GetObject(VTroms, rNode)));
        rNode := VTRoms.GetNextSelected(rNode);
      end;

      //now write the current ROMS file to disk, to get rid of moved roms
      ROMlist.SaveToFile();
      TmpList.LoadFromFile(txtFile);

      //now copy all the roms that were dropped into the list containing
      //the destination roms.
      for i := 0 to TmpRoms.Count-1 do
      begin
        NewIndex := TmpList.Add(TQPRom.Create);
        TmpList[NewIndex].Assign(TmpRoms[i]);
      end;

      TmpRoms.Clear;
      FreeAndNil(TmpRoms);
      TmpList.FileName := txtfile;
      TmpList.SaveToFile();
      TmpList.Clear;
      FreeAndNil(TmpList);

      //now we need to redraw the current romlisting to get
      //rid of the roms we dragged and dropped.
      FillRoms(GetSelectedTxt);

      VTRoms.EndUpdate;

    end; //end of IF source = VTRoms

  end;  //end of IF dataobject = nil

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirDragOver(Sender: TBaseVirtualTree;
  Source: TObject; Shift: TShiftState; State: TDragState; Pt: TPoint;
  Mode: TDropMode; var Effect: Integer; var Accept: Boolean);
var
  DropNode : PVirtualNode;
  CurDir : TQPDir;
begin
  Accept := False;
  if (Source = VTRoms) then
  begin
    DropNode := Sender.GetNodeAt(PT.X, PT.Y);
    CurDir := TQPDir(GetObject(Sender, DropNode));
    if (CurDir <> nil) and (CurDir.DirType = dtROMs) then
      Accept := True; 
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirEditing(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; var Allowed: Boolean);
var
  CurDir : TQPDir;
begin
  If Node <> nil then
  begin

    CurDir := TQPDir(GetObject(Sender, Node));
    If (CurDir.DirType <> dtROMs) or( VTDir.GetNodeLevel(Node) = 0) then
      Allowed := False
    else
      Allowed := true;

  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirExit(Sender: TObject);
begin
  if VTDir.IsEditing then
    VTDir.EndEditNode;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If (VTDir.FocusedNode <> nil) and (Key = VK_DELETE) then
    ActDelFol.Execute;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTdirNewText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; NewText: WideString);
var
  Parent, aNode : PVirtualNode;
  CurDir : TQPDir;
  NewDir : String;
  Exists : Boolean;
begin
  If (Node <> nil) and (NewText <> '') then
  begin
    CurDir := TQPDir(GetObject(Sender, Node));
    Parent := Node.Parent;
    Exists := False;
    If Parent.ChildCount > 1 then
    begin

      aNode := Parent.FirstChild;
      While aNode <> nil do
      begin
        if strCompare(TQPDir(GetObject(Sender, aNode)).DisplayText, NewText)=0 then
        Begin
          Exists := True;
          aNode := nil;
        end
        else
          aNode := aNode.NextSibling;
      end;

    end;

    If not Exists then
    begin
      NewDir := TQPDir(GetObject(Sender, Parent)).FullPath;
      NewDir := includeTrailingPathDelimiter(NewDir + NewText);
      RenameFile(CurDir.FullPath, NewDir);
      CurDir.DisplayText := NewText;
      CurDir.FullPath := NewDir;
    end;
  end;

end;

{------------------------end of code for virtual directory tree ---------}


procedure TMainFrm.jvDropROMDragDrop(Sender: TJvDropTarget;
  var Effect: TJvDropEffect; Shift: TShiftState; X, Y: Integer);
var
  inFiles : TStringList;
begin

  Effect := deLink;

  inFiles := TStringList.Create;
  try
    Sender.GetFilenames(inFiles);
    ROMList.AddFromStrings(inFiles, '', '', lmNone, False);
    FillRoms(GetSelectedTxt);
  finally
    FreeAndNil(inFiles);
  end;
  
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.jvDropROMDragAccept(Sender: TJvDropTarget;
  var Accept: Boolean);
begin
  Accept := True;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ChkEmuBySysClick(Sender: TObject);
begin
  InitEmuTree();
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTEmusInitChildren(Sender: TBaseVirtualTree;
  Node: PVirtualNode; var ChildCount: Cardinal);
var
  ChildNode: PVirtualNode;
  I : Integer;
  CurSys : TQPSystem;
  CurEmu : TQPEmu;
begin
  VTEmus.BeginUpdate;
  try
    CurSys := TQPSystem(GetObject(Sender, Node));

    //loop through all systems and add each one as a child.
    For i := 0 to EmuList.Count-1 do
    Begin
      CurEmu := EmuList.items[i];
      If StrCompare(CurEmu.System, CurSys.Name)=0 then
      begin

        ChildNode := Sender.AddChild(Node);
        SetObject(Sender, ChildNode, CurEmu);
        Sender.ValidateNode(Node, False);
      end;
    end;

    //the childcount is the amount of nodes we just added
    ChildCount := Sender.ChildCount[Node];

  finally
    //end the update cycle and refresh the tree.
    VTEmus.EndUpdate;
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTEmusInitNode(Sender: TBaseVirtualTree; ParentNode,
  Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
var
  CurSys : TQPSystem;
begin

  If ChkEmuBySys.Checked then
  begin
    //we want the emulators listed by system
    if VTEmus.GetNodeLevel(node) = 0 then
    begin
      SetObject(Sender, Node, SystemList.Items[Node.Index]);
      CurSys := TQPSystem(GetObject(Sender, Node));

      // use the GetEmulatorsFromSystem function to determine if
      // this system will have any child nodes.
      CurSys.TotalEmus := EmuList.TotalForSystem(CurSys.Name);
      If CurSys.TotalEmus <> 0 then
        Include(InitialStates, ivsHasChildren);
    end;
  end
  else
  begin
    //we want a flat emulator listing.
    SetObject(Sender, Node, EmuList[Node.Index]);
  end;

end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTEmusGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
var
  CurSys : TQPSystem;
begin
  if ChkEmuBySys.Checked then
  begin
    If VTEmus.GetNodeLevel(node) = 0 then
    begin
      //for the system i want to output the system name AND
      //how many emulators are in this system (if its not 0)
      CurSys := TQPSystem(GetObject(Sender, Node));
      If CurSys.TotalEmus = 0 then
        CellText := CurSys.Name
      else
        CellText := CurSys.Name + ' (' + IntToStr(CurSys.TotalEmus) + ')';
    end
    Else
      CellText := TQPEmu(GetObject(Sender, Node)).Name;
  end
  else
  begin
    CellText := TQPEmu(GetObject(Sender, Node)).Name;
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTEmusGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
begin
  If not ChkEmuBySys.Checked then
    ImageIndex := 2
  else
    If VTEmus.GetNodeLevel(node) = 0 then
      ImageIndex := 0
    else
      ImageIndex := 2;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTEmusDblClick(Sender: TObject);
var
  MyEmu : TQPEmu;
begin
  MyEmu := nil;
  If VTEmus.FocusedNode <> nil then
  begin
    if ChkEmuBySys.Checked then
    begin
      if (VTEmus.GetNodeLevel(VTEmus.FocusedNode)=1) then
        MyEmu := TQPEmu(GetObject(VTEmus, VTEmus.FocusedNode));
    end
    else
      MyEmu := TQPEmu(GetObject(VTEmus, VTEmus.FocusedNode));

    If MyEmu <> nil then
    begin
      if FileExists(MyEmu.Path) then
      begin
        MyEmu.MameConfigCheck;
        RunProcess(MyEmu.Path, false, ExtractFilePath(MyEmu.Path));
      end
      else
        MessageDlg(QP_FILE_NOT_EXIST, mtError, [mbOK], 0);
    end;
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.VTEmusCompareNodes(Sender: TBaseVirtualTree; Node1,
  Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
var
  Emu1, Emu2 : TQPEmu;
  Sys1, Sys2 : TQPSystem;
begin
  if ChkEmuBySys.Checked then
  begin
    If (Sender.GetNodeLevel(Node1) = 0) and
       (Sender.GetNodeLevel(Node2) = 0) then
    begin
      Sys1 := TQPSystem(GetObject(Sender, Node1));
      Sys2 := TQPSystem(GetObject(Sender, Node2));
      Result := CompareText(Sys1.Name, Sys2.Name);
    end
    else
      If (Sender.GetNodeLevel(Node1) = 1) and
         (Sender.GetNodeLevel(Node2) = 1) then
      begin
        Emu1 := TQPEmu(GetObject(Sender, Node1));
        Emu2 := TQPEmu(GetObject(Sender, Node2));
        Result := CompareText(Emu1.Name, Emu2.Name);
      end;
  end
  else
  begin
    Emu1 := TQPEmu(GetObject(Sender, Node1));
    Emu2 := TQPEmu(GetObject(Sender, Node2));
    Result := CompareText(Emu1.Name, Emu2.Name);
  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.jvThumbDblClick(Sender: TObject);
var
  theFile : String;
begin
  if (Sender is Tjvthumbview) and (tjvThumbView(Sender).SelectedFile <> '') then
  begin
    theFile := tjvThumbView(Sender).SelectedFile;

    //if its not an image then move it to the MiscFound stringlist
    if ujFile.FileIsImage(theFile) then
    begin
      ImgROM.Picture.LoadFromFile(theFile);
      jvThumb.Hide;
      ImgROM.Show;
    end
    else
      ShellExecute(Handle, 'open', PChar(theFile), '', '', sw_Show);

  end;
end;

{-----------------------------------------------------------------------------}

procedure TMainFrm.ImgROMDblClick(Sender: TObject);
begin
  ImgROM.Hide;
  jvThumb.Show;
end;

{-----------------------------------------------------------------------------}

end.
