unit uQPDir;

interface

type

  TQPDirType = (dtROMs, dtSearch);

  TQPDir = class
  protected
    FFullPath : String;
    FDisplay : String;
    FDirType : TQPDirType;
    FUseCustomIcon : boolean;
    FNormalIcon : Integer;
    FSelIcon : Integer;
  public
    Property FullPath : String Read FFullPath Write FFullPath;
    Property DisplayText : String Read FDisplay Write FDisplay;
    Property DirType : TQPDirType Read FDirType Write FDirType;
    Property CustomIcon : boolean Read FUseCustomIcon Write FUseCustomIcon;
    Property NormalIcon : Integer Read FNormalIcon Write FNormalIcon;
    Property SelIcon : Integer Read FSelIcon Write FSelIcon;
    constructor Create();overload;
    constructor Create(Display, Path : String; DirType : TQPDirType; CustomIcon : Boolean; NIcon, SIcon : Integer);overload;
  end;

implementation

{-----------------------------------------------------------------------------}
{ TQPDir }
{-----------------------------------------------------------------------------}

constructor TQPDir.Create;
begin
  FDisplay := '';
  FFullPath := '';
  FDirType := dtROMs;
  FUseCustomIcon := False;
  FNormalIcon := -1;
  FSelIcon := -1;
end;

constructor TQPDir.Create(Display, Path: String; DirType : TQPDirType;  CustomIcon: Boolean; NIcon,
  SIcon: Integer);
begin
  FDisplay := Display;
  FFullPath := Path;
  FDirType := DirType;
  FUseCustomIcon := CustomIcon;
  FNormalIcon := NIcon;
  FSelIcon := SIcon;
end;


end.
 