unit uQPVTQueryEditor;

interface

uses uQPVTEditor;

type

  TFilterEditLink = class(TQPVTEdit)
  protected
    procedure doCustomEnd();override;
    procedure doCustomPrepare();override;
  end;

implementation

uses uQuery, uJVirtualTree, StdCtrls, uQPConst;

{ TFilterEditLink }

procedure TFilterEditLink.doCustomEnd();
begin
  With Edit as TComboBox do
  begin
    If EditColumn = 0 then
    begin
      Case ItemIndex of
        0 : TQPQuery(GetObject(EditTree, EditNode)).mode := qmName;
        1 : TQPQuery(GetObject(EditTree, EditNode)).mode := qmFileName;
        2 : TQPQuery(GetObject(EditTree, EditNode)).mode := qmEmu;
        3 : TQPQuery(GetObject(EditTree, EditNode)).mode := qmCompany;
        4 : TQPQuery(GetObject(EditTree, EditNode)).mode := qmYear;
        5 : TQPQuery(GetObject(EditTree, EditNode)).mode := qmType;
        6 : TQPQuery(GetObject(EditTree, EditNode)).mode := qmNumPlay;
        7 : TQPQuery(GetObject(EditTree, EditNode)).mode := qmPlayers;
        8 : TQPQuery(GetObject(EditTree, EditNode)).mode := qmRating;
      end;
    end
    else
    begin
      //Its the contains box.
      if ItemIndex = 0 then
        TQPQuery(GetObject(EditTree, EditNode)).FullMatch := True
      else
        TQPQuery(GetObject(EditTree, EditNode)).FullMatch := False;
    end;
  end;//end of WITH statement
end;

Procedure TFilterEditLink.doCustomPrepare();
begin
  CreateCombo();
  With FEdit as TComboBox do
  begin
    Style := csDropDownList;
    case EditColumn of
      0:
      begin
        //Add the list of possible filters.
        Items.Add(QP_ROM_NAME_SHORT);
        Items.Add(QP_ROM_FILENAME);
        Items.Add(QP_ROM_EMU);
        Items.Add(QP_ROM_COMPANY);
        Items.Add(QP_ROM_YEAR);
        Items.Add(QP_ROM_TYPE);
        Items.Add(QP_ROM_NUM_PLAY);
        Items.Add(QP_ROM_PLAYERS);
        Items.Add(QP_ROM_RATING);
        ItemIndex := Items.IndexOf(TQPQuery(GetObject(EditTree, EditNode)).ModeToStr);
      end;
      1:
      begin
        Items.Add(QP_QUERY_IS);
        Items.Add(QP_QUERY_CONTAIN);
        if TQPQuery(GetObject(EditTree, EditNode)).FullMatch then
          ItemIndex := 0
        else
          ItemIndex := 1;
      end;
    end;
  end;//end of WITH statement
end;

end.
 
