unit uQuery;

interface

Type

  TQPQueryMode = (qmName,
                  qmFileName,
                  qmEmu,
                  qmCompany,
                  qmYear,
                  qmType,
                  qmNumPlay,
                  qmPlayers,
                  qmRating);

  TQPQuery = Class
    Public
      mode : TQPQueryMode;
      Filter : String;
      FullMatch : Boolean;
      constructor create(cmode : TQPQueryMode; cFilter : String; cFullMatch : Boolean);overload;
      constructor create(InString : String);overload;
      Function ModeToStr() : String;
      Function StrToMode(input : String) : TQPQueryMode;
      procedure FromString(input : String);
      function ToString() : String;
  end;

implementation

uses Classes, SysUtils, JCLStrings;

Constructor TQPQuery.create(cmode : TQPQueryMode; cFilter : String; cFullMatch : Boolean);
begin
  mode := cMode;
  Filter := cFilter;
  FullMatch := cFullMatch;
end;

constructor TQPQuery.create(InString : String);
begin
  FromString(inString);
end;

Function TQPQuery.ModeToStr() : String;
begin
  Case mode of
    qmName : Result := 'Name';
    qmFileName : Result := 'FileName';
    qmEmu : Result := 'Emulator';
    qmCompany : Result := 'Company';
    qmYear : Result := 'Year';
    qmType : Result := 'Game Type';
    qmNumPlay : Result := 'Number of Times Played';
    qmPlayers : result := 'Players';
    qmRating : Result := 'Rating';
    else
      Result := '';
  end;
end;

Function TQPQuery.StrToMode(input : String) : TQPQueryMode;
begin
  if input = 'Name' then
    Result := qmName
  else if input = 'FileName' then
    Result := qmFileName
  else if input = 'Emulator' then
    Result := qmEmu
  else if input = 'Company' then
    Result := qmCompany
  else if input = 'Year' then
    Result := qmYear
  else if input = 'Game Type' then
    Result := qmType
  else if input = 'Number of Times Played' then
    Result := qmNumPlay
  else if input = 'Players' then
    Result := qmPlayers
  else if input = 'Rating' then
    Result := qmRating
  else
    Result := qmName; //we SHOULD NEVER GET HERE!!
end;

procedure TQPQuery.FromString(input : String);
var
  SplitList : TStringList;
begin
  //we need to create our splitlist stringlist
  SplitList := TStringList.Create;
  try
    // this function is from jedi code library.
    StrTokenToStrings(input, '', SplitList);
    Mode := StrToMode(SplitList[0]);
    Filter := SplitList[1];
    FullMatch := StrToBool(SplitList[2]);
  finally
    FreeAndNil(SplitList);
  end;
end;

function TQPQuery.ToString() : String;
begin
  Result := ModeToStr() + '' + Filter + '' + BoolToStr(FullMatch);
end;

end.
